      SUBROUTINE MOMENTA(ECM,Q,WT,DD)
C-----------------------------------------------------------------------
      IMPLICIT NONE
      REAL*8 Q,WT,DD,MZ,GZ,XM,PP,ECM,ML
      INTEGER NIK,N4
      DIMENSION q(4,7),xm(100),pp(4,100)
      COMMON /MZGZ/ MZ,GZ
      COMMON /LIMITS/ ML
C-----------------------------------------------------------------------
      XM(1)=ML
      XM(2)=ML
      XM(3)=0.d0
      CALL RAMBO(3,ECM,XM,PP,WT,DD)
      DO 78 NIK=1,3
       DO 78 N4=1,4
 78   Q(N4,NIK+2)=PP(N4,NIK)
      RETURN
      END 

       SUBROUTINE CHECK_CUTS(ecm,Q,NCUT)
C-----------------------------------------------------------------------
C Input parameters:
C     Q(4,7) : 4-MOMENTA: 1,2-TRANSVERSE, 3 ALONG ELECTRON, 4 ENERGY
C     FOR    THE FOLLOWING PARTICLES
C            1- INCOMING POSITRON, 2-INCOMING ELECTRON
C            3- NEUTRINO L, 4-ANTINEUTRINO L
C            5- PHOTON
C  ECM = Center-of-mass energy (in GeV)
C Output parameter:
C  NCUT = 0 if particles satisfies the cuts; = 1 if not
C-----------------------------------------------------------------------
      IMPLICIT NONE
      REAL*8 Q(4,7),Ephot,ANGLE,MVV,M34,CT5,MZ,P34(4),ECM
      REAL  EGAMG,ECOSG,WTG,PTG,XTG
      COMMON/CUTS/Ephot,ANGLE,MVV
      INTEGER NCUT,N
C VVVVVVVVVVVVVVVVVVVVVV  JB 970403 VVVVVVVVVVVVVVVVVVVVVVVV
C
C*CA PHCUTS
      REAL EPHMIN,EPHMAX,XTFMIN,XTFMAX,COSTHM
      COMMON / PHCUTS / EPHMIN,EPHMAX,XTFMIN,XTFMAX,COSTHM
      real tabl
      COMMON / gengto / TABL(40)
C*CC PHCUTS
C ^^^^^^^^^^^^^^^^^^^^^ JB 970403 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
       MZ=tabl(13)
c  set ncut=1 if cuts not passeD
       ncut=1
c--
      PTG = DSQRT(Q(1,5)**2+Q(2,5)**2)
      XTG = 2.0*PTG/ecm
C vvvvvvvvvvvvv begin mods JB 970403 vvvvvvvvvvvvvvvvvvvv
      if (XTG.LT.XTFMIN) RETURN
      if (XTG.GT.XTFMAX) RETURN
      if (Q(4,5).LT.DBLE(EPHMIN)) RETURN
      if (Q(4,5).GT.DBLE(EPHMAX)) return
C ^^^^^^^^^^^^^^^^^^^^^ JB 970403 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
      EGAMG = Q(4,5)
      CT5=DABS(Q(3,5)/Q(4,5))
      ECOSG = CT5
      IF (CT5.GT.DBLE(COSTHM)) RETURN
!      write(*,*) 'f'
      DO N=1,4
         P34(N)=Q(N,3)+Q(N,4)
      ENDDO
      M34=DSQRT(P34(4)**2-P34(1)**2-P34(2)**2-P34(3)**2)
      IF(DABS(M34-MZ).LT.MVV) RETURN
      NCUT=0
      RETURN
      END
      SUBROUTINE XSECTION(SIG,Q)
C----------------------------------------------------------------------
C CALCULATES CONTRIBUTION TO XSECTION FOR LL+PHOTON FOR GIVEN MOMENTA
C INPUT: Q(4,7) - 4-MOMENTA: 1,2-TRANSVERSE, 3 ALONG ELECTRON, 4 ENERGY
C     FOR    THE FOLLOWING PARTICLES
C            1- INCOMING POSITRON, 2-INCOMING ELECTRON
C            3- NEUTRINO L, 4-ANTINEUTRINO L
C            5- PHOTON
C OUTPUT: SIG: CONTRIBUTION TO XSEC (TO BE MULTIPLIED BY PROPER WEIGHT)
c              FOR COMBINATIONS OF ANOMALOUS COUPLINGS
C----------------------------------------------------------------------
      IMPLICIT NONE
      REAL*8 Q,P1,P2,P3,P4,P5,SIG(6),S1(6),S2,sepem_vmvma ,MZ,GZ
      external sepem_vmvma
      INTEGER N
      DIMENSION Q(4,7),P1(0:3),P2(0:3),P3(0:3),P4(0:3),P5(0:3)
      integer nwwg,nneutr
      common /flags/ nwwg,nneutr
      COMMON /MZGZ/  MZ,GZ
C----------------------------------------------------------------------
      S2=0.D0
      DO N=1,6
         S1(N)=0.D0
      ENDDO
      DO N=1,3
         P1(N)=Q(N,1)
         P2(N)=Q(N,2)
         P3(N)=Q(N,3)
         P4(N)=Q(N,4)
         P5(N)=Q(N,5)
      ENDDO
      P1(0)=Q(4,1)
      P2(0)=Q(4,2)
      P3(0)=Q(4,3)
      P4(0)=Q(4,4)
      P5(0)=Q(4,5)
C ELECTRON NEUTRINOS
      CALL SEPEM_VEVEA(P1,P2,P3,P4,P5,S1)
      S2=0.d0
C MUON + TAU NEUTRINOS
      if(nneutr.eq.3)   S2= SEPEM_VMVMA(P1,P2,P3,P4,P5)
      DO N=1,6
         SIG(N)=S1(N)+2.D0*S2
      ENDDO
      RETURN
      END
      REAL*8 FUNCTION G(Q,P)
C-------------------------------------------------------------------------
C DOT PRODUCT OF VECTORS Q P
C-------------------------------------------------------------------------
      IMPLICIT REAL*8(A-M,O-Z)
      DIMENSION Q(4),P(4)
C-------------------------------------------------------------------------
      G=Q(4)*P(4)-Q(1)*P(1)-Q(2)*P(2)-Q(3)*P(3)
      RETURN
      END
      SUBROUTINE RAMBO(N,ET,XM,P,WT,DD)
C------------------------------------------------------
C
C                       RAMBO
C
C    RA(NDOM)  M(OMENTA)  B(EAUTIFULLY)  O(RGANIZED)
C
C    A DEMOCRATIC MULTI-PARTICLE PHASE SPACE GENERATOR
C    AUTHORS:  S.D. ELLIS,  R. KLEISS,  W.J. STIRLING
C    THIS IS VERSION 1.0 -  WRITTEN BY R. KLEISS
C
C    N  = NUMBER OF PARTICLES (>1, IN THIS VERSION <101)
C    ET = TOTAL CENTRE-OF-MASS ENERGY
C    XM = PARTICLE MASSES ( DIM=100 )
C    P  = PARTICLE MOMENTA ( DIM=(4,100) )
C    WT = WEIGHT OF THE EVENT
C
C------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION XM(10),P(4,100),Q(4,100),Z(100),R(4),
     .   B(3),P2(100),XM2(100),E(100),V(100),IWARN(5)
      integer inut,iout
      COMMON / INOUT / INUT,IOUT
      DATA ACC/1.D-14/,ITMAX/6/,IBEGIN/0/,IWARN/5*0/
C
C INITIALIZATION STEP: FACTORIALS FOR THE PHASE SPACE WEIGHT
      IF(IBEGIN.NE.0) GOTO 103
      IBEGIN=1
      TWOPI=8.*DATAN(1.D0)
      PO2LOG=DLOG(TWOPI/4.)
      Z(2)=PO2LOG
      DO 101 K=3,100
  101 Z(K)=Z(K-1)+PO2LOG-2.*DLOG(DBLE(K-2))
      DO 102 K=3,100
  102 Z(K)=(Z(K)-DLOG(DBLE(K-1)))
C
C CHECK ON THE NUMBER OF PARTICLES
  103 IF(N.GT.1.AND.N.LT.101) GOTO 104
      write(iout,1001) N
      STOP
C
C CHECK WHETHER TOTAL ENERGY IS SUFFICIENT; COUNT NONZERO MASSES
  104 XMT=0.
      NM=0
      DO 105 I=1,N
      IF(XM(I).NE.0.D0) NM=NM+1
  105 XMT=XMT+DABS(XM(I))
      IF(XMT.LE.ET) GOTO 201
      write(iout,1002) XMT,ET
      STOP
C
C THE PARAMETER VALUES ARE NOW ACCEPTED
C
C GENERATE N MASSLESS MOMENTA IN INFINITE PHASE SPACE
  201 DO 202 I=1,N
      C=2.*RANDY(DD)-1.
      S=DSQRT(1.-C*C)
      F=TWOPI*RANDY(DD)
      Q(4,I)=-DLOG(RANDY(DD)*RANDY(DD))
      Q(3,I)=Q(4,I)*C
      Q(2,I)=Q(4,I)*S*DCOS(F)
  202 Q(1,I)=Q(4,I)*S*DSIN(F)
C
C CALCULATE THE PARAMETERS OF THE CONFORMAL TRANSFORMATION
      DO 203 I=1,4
  203 R(I)=0.
      DO 204 I=1,N
      DO 204 K=1,4
  204 R(K)=R(K)+Q(K,I)
      RMAS=DSQRT(R(4)**2-R(3)**2-R(2)**2-R(1)**2)
      DO 205 K=1,3
  205 B(K)=-R(K)/RMAS
      G=R(4)/RMAS
      A=1./(1.+G)
      X=ET/RMAS
C
C TRANSFORM THE Q'S CONFORMALLY INTO THE P'S
      DO 207 I=1,N
      BQ=B(1)*Q(1,I)+B(2)*Q(2,I)+B(3)*Q(3,I)
      DO 206 K=1,3
  206 P(K,I)=X*(Q(K,I)+B(K)*(Q(4,I)+A*BQ))
  207 P(4,I)=X*(G*Q(4,I)+BQ)
C
C CALCULATE WEIGHT AND POSSIBLE WARNINGS
      WT=PO2LOG
      IF(N.NE.2) WT=(2.*N-4.)*DLOG(ET)+Z(N)
      IF(WT.GE.-180.D0) GOTO 208
      IF(IWARN(1).LE.5) write(iout,1004) WT
      IWARN(1)=IWARN(1)+1
  208 IF(WT.LE. 174.D0) GOTO 209
      IF(IWARN(2).LE.5) write(iout,1005) WT
      IWARN(2)=IWARN(2)+1
C
C RETURN FOR WEIGHTED MASSLESS MOMENTA
  209 IF(NM.NE.0) GOTO 210
      WT=DEXP(WT)
      RETURN
C
C MASSIVE PARTICLES: RESCALE THE MOMENTA BY A FACTOR X
  210 XMAX=DSQRT(1.-(XMT/ET)**2)
      DO 301 I=1,N
      XM2(I)=XM(I)**2
  301 P2(I)=P(4,I)**2
      ITER=0
      X=XMAX
      ACCU=ET*ACC
  302 F0=-ET
      G0=0.
      X2=X*X
      DO 303 I=1,N
      E(I)=DSQRT(XM2(I)+X2*P2(I))
      F0=F0+E(I)
  303 G0=G0+P2(I)/E(I)
      IF(DABS(F0).LE.ACCU) GOTO 305
      ITER=ITER+1
      IF(ITER.LE.ITMAX) GOTO 304
      write(iout,1006) ITMAX
      GOTO 305
  304 X=X-F0/(X*G0)
      GOTO 302
  305 DO 307 I=1,N
      V(I)=X*P(4,I)
      DO 306 K=1,3
  306 P(K,I)=X*P(K,I)
  307 P(4,I)=E(I)
C
C CALCULATE THE MASS-EFFECT WEIGHT FACTOR
      WT2=1.
      WT3=0.
      DO 308 I=1,N
      WT2=WT2*V(I)/E(I)
  308 WT3=WT3+V(I)**2/E(I)
      WTM=(2.*N-3.)*DLOG(X)+DLOG(WT2/WT3*ET)
C
C RETURN FOR  WEIGHTED MASSIVE MOMENTA
      WT=WT+WTM
      IF(WT.GE.-180.D0) GOTO 309
      IF(IWARN(3).LE.5) write(iout,1004) WT
      IWARN(3)=IWARN(3)+1
  309 IF(WT.LE. 174.D0) GOTO 310
      IF(IWARN(4).LE.5) write(iout,1005) WT
      IWARN(4)=IWARN(4)+1
  310 WT=DEXP(WT)
      RETURN
C
 1001 FORMAT(' RAMBO FAILS: # OF PARTICLES =',I5,' IS NOT ALLOWED')
 1002 FORMAT(' RAMBO FAILS: TOTAL MASS =',D15.6,' IS NOT',
     . ' SMALLER THAN TOTAL ENERGY =',D15.6)
 1004 FORMAT(' RAMBO WARNS: WEIGHT = EXP(',F20.9,') MAY UNDERFLOW')
 1005 FORMAT(' RAMBO WARNS: WEIGHT = EXP(',F20.9,') MAY  OVERFLOW')
 1006 FORMAT(' RAMBO WARNS:',I3,' ITERATIONS DID NOT GIVE THE',
     . ' DESIRED ACCURACY =',D15.6)
      END
       double precision function ran(dseed)
C ------------------------------------------------------------------------
c
      double precision dseed
      double precision d2m,d2
      data   d2m/2147483647.d0/,d2/2147483648.d0/
C ------------------------------------------------------------------------
      dseed=dmod(16807.d0*dseed,d2m)
      ran=dseed / d2
      return
      end
      SUBROUTINE BOOST(PBOO,PIN,POUT)
C ------------------------------------------------------------------------
C COMPONENT 4 IS ENERGY
C Q IS THE INVARIANT MASS OF PBOO, PIN THE INPUT VECTOR, POUT
C THE OUTPUT VECTOR AND THE BOOST CAN BE EITHER FROM Q REST
C FRAME TO THE PBOO VECTOR GIVEN, OR FROM A GIVEN PBOO TO
C THE Q REST FRAME BY CALLING AS A FUNCTION OF PBOOT INSTEAD
C OF THE ABOVE WHERE PBOOT HAS REVERSED SPACE COMPONENTS FROM PBOO
C ------------------------------------------------------------------------
      IMPLICIT REAL*8(A-M,P-Z)
      DIMENSION PBOO(4),PIN(4),POUT(4)
C ------------------------------------------------------------------------
      Q=DSQRT(PBOO(4)**2-PBOO(3)**2-PBOO(2)**2-PBOO(1)**2)
      POUT(4)=(PBOO(4)*PIN(4)+PBOO(3)*PIN(3)+PBOO(2)*PIN(2)+
     +         PBOO(1)*PIN(1))/Q
      FACT =(PIN(4)+POUT(4))/(Q+PBOO(4))
      DO 10 N=1,3
   10 POUT(N)=PIN(N)+FACT*PBOO(N)
      RETURN
      END
      REAL*8 FUNCTION RANDY(IDUM)
C ------------------------------------------------------------------------
C returns a uniform deviate between 0. and 1. using a routine
C RAN(ISEED). Set IDUM to any negative value to initialize.
C ------------------------------------------------------------------------
      IMPLICIT REAL*8(A-I,K-Z)
      EXTERNAL RAN
      DIMENSION V(97)
      DATA IFF /0.D0/
C ------------------------------------------------------------------------
      IF (IDUM.LT.0.D0.OR.IFF.EQ.0.D0) THEN
        IFF=1.D0
        ISEED=DABS(IDUM)
        IDUM=1.D0
        DO 11 J=1,97
          DUM=RAN(ISEED)
11      CONTINUE
        DO 12 J=1,97
          V(J)=RAN(ISEED)
12      CONTINUE
        Y=RAN(ISEED)
      ENDIF
      J=1+IDINT(97.D0*Y)
      IF(J.GT.97.OR.J.LT.1)GOTO 10
      Y=V(J)
      RANDY=Y
      IF(RANDY.EQ.0.D0.OR.RANDY.EQ.1.D0) GOTO 9
      V(J)=RAN(ISEED)
      RETURN
 10   WRITE(*,*)'RANDY FAILS, J OUT OF RANGE'
      STOP
  9   WRITE(*,*)' ZERO OR ONE GENERATED',RANDY
      RETURN
      END
      subroutine initialize
C ------------------------------------------------------------------------
C     sets up masses and coupling constants for Helas
C ------------------------------------------------------------------------
      implicit none
      real tabl
      COMMON / gengto / TABL(40)

C Constants
C
      double precision  sw2
!      parameter        (sw2 = .2293d0)
C   masses and widths of fermions
      double precision tmass,      bmass,     cmass
      parameter       (tmass=175d0,bmass=5d0, cmass=0d0)
      double precision smass,      umass,     dmass
      parameter       (smass=0d0,  umass=0d0, dmass=0d0)
      double precision twidth,     bwidth,    cwidth
      parameter       (twidth=0d0, bwidth=0d0,cwidth=0d0)
      double precision swidth,     uwidth,    dwidth
      parameter       (swidth=0d0, uwidth=0d0,dwidth=0d0)
      double precision emass,      mumass,    taumass
      parameter       (emass=0d0,  mumass=0d0,taumass=0d0)
      double precision ewidth,     muwidth,    tauwidth
      parameter       (ewidth=0d0, muwidth=0d0,tauwidth=0d0)
C   masses and widths of bosons
      double precision wmass,         zmass
!      parameter       (wmass=80.046485d0,    zmass=91.18d0)
      double precision wwidth,        zwidth
!      parameter       (wwidth=2.2d0, zwidth=2.484d0)
      double precision amass,         awidth
      parameter       (amass=0d0,     awidth=0d0)
      double precision hmass,         hwidth
      parameter       (hmass=150d0,   hwidth=1d0)
C
C Local Variables
C
      integer i
C
C Global Variables
C
      double precision  gw, gwwa, gwwz
      common /coup1/    gw, gwwa, gwwz
      double precision  gal(2),gau(2),gad(2),gwf(2)
      common /coup2a/   gal,   gau,   gad,   gwf
      double precision  gzn(2),gzl(2),gzu(2),gzd(2),g1(2)
      common /coup2b/   gzn,   gzl,   gzu,   gzd,   g1
      double precision  gwwh,gzzh,ghhh,gwwhh,gzzhh,ghhhh
      common /coup3/    gwwh,gzzh,ghhh,gwwhh,gzzhh,ghhhh
      complex*16        gchf(2,12)
      common /coup4/    gchf
      double precision  wmass1,wwidth1,zmass1,zwidth1
      common /vmass1/   wmass1,wwidth1,zmass1,zwidth1
      double precision  amass1,awidth1,hmass1,hwidth1
      common /vmass2/   amass1,awidth1,hmass1,hwidth1
      double precision  fmass(12), fwidth(12)
      common /fermions/ fmass,     fwidth
      double precision  gg(2), g
      common /coupqcd/  gg,    g
C ------------------------------------------------------------------------
!-----------
! Begin Code
!-----------

      zmass= tabl(13)
      zwidth=tabl(14)
      wmass= tabl(15)
      wwidth=tabl(16)
      sw2=   tabl(17)
      fmass(1) = emass
      fmass(2) = 0d0
      fmass(3) = umass
      fmass(4) = dmass
      fmass(5) = mumass
      fmass(6) = 0d0
      fmass(7) = cmass
      fmass(8) = smass
      fmass(9) = taumass
      fmass(10)= 0d0
      fmass(11)= tmass
      fmass(12)= bmass
C
      fwidth(1) = ewidth
      fwidth(2) = 0d0
      fwidth(3) = uwidth
      fwidth(4) = dwidth
      fwidth(5) = muwidth
      fwidth(6) = 0d0
      fwidth(7) = cwidth
      fwidth(8) = swidth
      fwidth(9) = tauwidth
      fwidth(10)= 0d0
      fwidth(11)= twidth
      fwidth(12)= bwidth
C
      wmass1=wmass
      zmass1=zmass
      amass1=amass
      hmass1=hmass
      wwidth1=wwidth
      zwidth1=zwidth
      awidth1=awidth
      hwidth1=hwidth
C
C  Calls to Helas routines to set couplings
C
      call coup1x(sw2,gw,gwwa,gwwz)
      call coup2x(sw2,gal,gau,gad,gwf,gzn,gzl,gzu,gzd,g1)
      call coup3x(sw2,zmass,hmass,gwwh,gzzh,ghhh,gwwhh,gzzhh,ghhhh)
      do i=1,12
         call coup4x(sw2,zmass,fmass(i),gchf(1,i))
      enddo
C
C  QCD couplings
C
      g = 1d0
      gg(1)=-g
      gg(2)=-g
C
      return
      end
      subroutine coup1x(sw2 , gw,gwwa,gwwz)
C ------------------------------------------------------------------------
c
c this subroutine sets up the coupling constants of the gauge bosons in
c the standard model.
c
c input:
c       real    sw2            : square of sine of the weak angle
c
c output:
c       real    gw             : weak coupling constant
c       real    gwwa           : dimensionless coupling of w-,w+,a
c       real    gwwz           : dimensionless coupling of w-,w+,z
C ------------------------------------------------------------------------
      real*8    sw2,gw,gwwa,gwwz,alpha,fourpi,ee,sw,cw
c
      real*8 r_one, r_four, r_ote, r_pi, r_ialph
      parameter( r_one=1.0d0, r_four=4.0d0, r_ote=128.0d0 )
      parameter( r_pi=3.14159265358979323846d0, r_ialph=137.03604d0 )
C ------------------------------------------------------------------------
c
      alpha = r_one / r_ote
ccAJ 25/11/96
      alpha = r_one / r_ialph
      fourpi = r_four * r_pi
      ee=sqrt( alpha * fourpi )
      sw=sqrt( sw2 )
      cw=sqrt( r_one - sw2 )
c
      gw    =  ee/sw
      gwwa  =  ee
      gwwz  =  ee*cw/sw
c
      return
      end
      subroutine coup2x(sw2 , gal,gau,gad,gwf,gzn,gzl,gzu,gzd,g1)
C ----------------------------------------------------------------------
c
c this subroutine sets up the coupling constants for the fermion-
c fermion-vector vertices in the standard model.  the array of the
c couplings specifies the chirality of the flowing-in fermion.  g??(1)
c denotes a left-handed coupling, and g??(2) a right-handed coupling.
c
c input:
c       real    sw2            : square of sine of the weak angle
c
c output:
c       real    gal(2)         : coupling with a of charged leptons
c       real    gau(2)         : coupling with a of up-type quarks
c       real    gad(2)         : coupling with a of down-type quarks
c       real    gwf(2)         : coupling with w-,w+ of fermions
c       real    gzn(2)         : coupling with z of neutrinos
c       real    gzl(2)         : coupling with z of charged leptons
c       real    gzu(2)         : coupling with z of up-type quarks
c       real    gzd(2)         : coupling with z of down-type quarks
c       real    g1(2)          : unit coupling of fermions
C ----------------------------------------------------------------------
c
      real*8 gal(2),gau(2),gad(2),gwf(2),gzn(2),gzl(2),gzu(2),gzd(2),
     &     g1(2),sw2,alpha,fourpi,ee,sw,cw,ez,ey
c
      real*8 r_zero, r_half, r_one, r_two, r_three, r_four, r_ote
      real*8 r_pi, r_ialph
      parameter( r_zero=0.0d0, r_half=0.5d0, r_one=1.0d0, r_two=2.0d0,
     $     r_three=3.0d0 )
      parameter( r_four=4.0d0, r_ote=128.0d0 )
      parameter( r_pi=3.14159265358979323846d0, r_ialph=137.03604d0 )
C ----------------------------------------------------------------------
c
      alpha = r_one / r_ote
ccAJ 25/11/96
      alpha = r_one / r_ialph
      fourpi = r_four * r_pi
      ee=sqrt( alpha * fourpi )
      sw=sqrt( sw2 )
      cw=sqrt( r_one - sw2 )
      ez=ee/(sw*cw)
      ey=ee*(sw/cw)
c
      gal(1) =  ee
      gal(2) =  ee
      gau(1) = -ee*r_two/r_three
      gau(2) = -ee*r_two/r_three
      gad(1) =  ee   /r_three
      gad(2) =  ee   /r_three
      gwf(1) = -ee/sqrt(r_two*sw2)
      gwf(2) =  r_zero
      gzn(1) = -ez*  r_half
      gzn(2) =  r_zero
      gzl(1) = -ez*(-r_half+sw2)
      gzl(2) = -ey
      gzu(1) = -ez*( r_half-sw2*r_two/r_three)
      gzu(2) =  ey*          r_two/r_three
      gzd(1) = -ez*(-r_half+sw2   /r_three)
      gzd(2) = -ey             /r_three
      g1(1)  =  r_one
      g1(2)  =  r_one
c
      return
      end
      subroutine coup3x(sw2,zmass,hmass ,
     &                  gwwh,gzzh,ghhh,gwwhh,gzzhh,ghhhh)
C ----------------------------------------------------------------------
c
c this subroutine sets up the coupling constants of the gauge bosons and
c higgs boson in the standard model.
c
c input:
c       real    sw2            : square of sine of the weak angle
c       real    zmass          : mass of z
c       real    hmass          : mass of higgs
c
c output:
c       real    gwwh           : dimensionful  coupling of w-,w+,h
c       real    gzzh           : dimensionful  coupling of z, z, h
c       real    ghhh           : dimensionful  coupling of h, h, h
c       real    gwwhh          : dimensionful  coupling of w-,w+,h, h
c       real    gzzhh          : dimensionful  coupling of z, z, h, h
c       real    ghhhh          : dimensionless coupling of h, h, h, h
C ----------------------------------------------------------------------
c
      real*8    sw2,zmass,hmass,gwwh,gzzh,ghhh,gwwhh,gzzhh,ghhhh,
     &        alpha,fourpi,ee2,sc2,v
c
      real*8 r_half, r_one, r_two, r_three, r_four, r_ote
      real*8 r_pi, r_ialph
      parameter( r_half=0.5d0, r_one=1.0d0, r_two=2.0d0, r_three=3.0d0 )
      parameter( r_four=4.0d0, r_ote=128.0d0 )
      parameter( r_pi=3.14159265358979323846d0, r_ialph=137.03604d0 )
C ----------------------------------------------------------------------
c
ccAJ 25/11/96
      alpha = r_one / r_ote
      alpha = r_one / r_ialph
      fourpi = r_four * r_pi
      ee2=alpha*fourpi
      sc2=sw2*( r_one - sw2 )
      v = r_two * zmass*sqrt(sc2)/sqrt(ee2)
c
      gwwh  =   ee2/sw2*r_half*v
      gzzh  =   ee2/sc2*r_half*v
      ghhh  =  -hmass**2/v*r_three
      gwwhh =   ee2/sw2*r_half
      gzzhh =   ee2/sc2*r_half
      ghhhh = -(hmass/v)**2*r_three
c
      return
      end
         SUBROUTINE COUP4X(SW2,ZMASS,FMASS , GCHF)
C ----------------------------------------------------------------------
C
C This subroutine sets up the coupling constant for the fermion-fermion-
C Higgs vertex in the STANDARD MODEL.  The coupling is COMPLEX and the
C array of the coupling specifies the chirality of the flowing-IN
C fermion.  GCHF(1) denotes a left-handed coupling, and GCHF(2) a right-
C handed coupling.
C
C INPUT:
C       real    SW2            : square of sine of the weak angle
C       real    ZMASS          : Z       mass
C       real    FMASS          : fermion mass
C
C OUTPUT:
C       complex GCHF(2)        : coupling of fermion and Higgs
C ----------------------------------------------------------------------
C
      implicit none
      COMPLEX*16 GCHF(2)
      REAL*8    SW2,ZMASS,FMASS,ALPHA,FOURPI,EZ,G
C ----------------------------------------------------------------------
C
ccAJ 25/11/96
      ALPHA=1.d0/128.d0
      ALPHA=1./REAL(137.03604)
      FOURPI=4.D0*3.14159265358979323846D0
      EZ=SQRT(ALPHA*FOURPI)/SQRT(SW2*(1.d0-SW2))
      G=EZ*FMASS*0.5d0/ZMASS
C
      GCHF(1) = DCMPLX( -G )
      GCHF(2) = DCMPLX( -G )
C
      RETURN
      END
      subroutine fvixxx(fi,vc,g,fmass,fwidth , fvi)
C ----------------------------------------------------------------------
c
c this subroutine computes an off-shell fermion wavefunction from a
c flowing-in external fermion and a vector boson.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex vc(6)          : input    vector                      v
c       real    g(2)           : coupling constants                  gvf
c       real    fmass          : mass  of output fermion f'
c       real    fwidth         : width of output fermion f'
c
c output:
c       complex fvi(6)         : off-shell fermion             |f',v,fi>
C ----------------------------------------------------------------------
c
      complex*16 fi(6),vc(6),fvi(6),sl1,sl2,sr1,sr2,d
      real*8    g(2),pf(0:3),fmass,fwidth,pf2
c
      real*8 r_zero, r_one
      parameter( r_zero=0.0d0, r_one=1.0d0 )
      complex*16 c_imag
C ----------------------------------------------------------------------
      c_imag=dcmplx( 0.d0, 1.d0 )
c
      fvi(5) = fi(5)-vc(5)
      fvi(6) = fi(6)-vc(6)
c
      pf(0)=dble( fvi(5))
      pf(1)=dble( fvi(6))
      pf(2)=dimag(fvi(6))
      pf(3)=dimag(fvi(5))
      pf2=pf(0)**2-(pf(1)**2+pf(2)**2+pf(3)**2)
c
CAJ 26/03/1997
      if (dcmplx( pf2-fmass**2,max(sign(fmass*fwidth,pf2),r_zero))
     &   .ne.r_zero) then
CAJ 26/03/1997
      d=-r_one/dcmplx( pf2-fmass**2,max(sign(fmass*fwidth,pf2),r_zero))
      sl1= (vc(1)+       vc(4))*fi(1)
     &    +(vc(2)-c_imag*vc(3))*fi(2)
      sl2= (vc(2)+c_imag*vc(3))*fi(1)
     &    +(vc(1)-       vc(4))*fi(2)
c
      if ( g(2) .ne. r_zero ) then
         sr1= (vc(1)-       vc(4))*fi(3)
     &       -(vc(2)-c_imag*vc(3))*fi(4)
         sr2=-(vc(2)+c_imag*vc(3))*fi(3)
     &       +(vc(1)+       vc(4))*fi(4)
c
         fvi(1) = ( g(1)*((pf(0)-pf(3))*sl1 -dconjg(fvi(6))*sl2)
     &             +g(2)*fmass*sr1)*d
         fvi(2) = ( g(1)*(      -fvi(6)*sl1 +(pf(0)+pf(3))*sl2)
     &             +g(2)*fmass*sr2)*d
         fvi(3) = ( g(2)*((pf(0)+pf(3))*sr1 +dconjg(fvi(6))*sr2)
     &             +g(1)*fmass*sl1)*d
         fvi(4) = ( g(2)*(       fvi(6)*sr1 +(pf(0)-pf(3))*sr2)
     &             +g(1)*fmass*sl2)*d
c
      else
         fvi(1) = g(1)*((pf(0)-pf(3))*sl1 -dconjg(fvi(6))*sl2)*d
         fvi(2) = g(1)*(      -fvi(6)*sl1 +(pf(0)+pf(3))*sl2)*d
         fvi(3) = g(1)*fmass*sl1*d
         fvi(4) = g(1)*fmass*sl2*d
      end if
c
CAJ 26/03/1997
      else
         fvi(1) = r_zero
         fvi(2) = r_zero
         fvi(3) = r_zero
         fvi(4) = r_zero
      endif
CAJ 26/03/1997
      return
      end
c
      subroutine fvoxxx(fo,vc,g,fmass,fwidth , fvo)
C ----------------------------------------------------------------------
c
c this subroutine computes an off-shell fermion wavefunction from a
c flowing-out external fermion and a vector boson.
c
c input:
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex vc(6)          : input    vector                      v
c       real    g(2)           : coupling constants                  gvf
c       real    fmass          : mass  of output fermion f'
c       real    fwidth         : width of output fermion f'
c
c output:
c       complex fvo(6)         : off-shell fermion             <fo,v,f'|
C ----------------------------------------------------------------------
c
c
      complex*16 fo(6),vc(6),fvo(6),sl1,sl2,sr1,sr2,d
      real*8    g(2),pf(0:3),fmass,fwidth,pf2
c
      real*8 r_zero, r_one
      parameter( r_zero=0.0d0, r_one=1.0d0 )
      complex*16 c_imag
C ----------------------------------------------------------------------
      c_imag=dcmplx( 0.d0, 1.d0 )
c
      fvo(5) = fo(5)+vc(5)
      fvo(6) = fo(6)+vc(6)
c
      pf(0)=dble( fvo(5))
      pf(1)=dble( fvo(6))
      pf(2)=dimag(fvo(6))
      pf(3)=dimag(fvo(5))
      pf2=pf(0)**2-(pf(1)**2+pf(2)**2+pf(3)**2)
c
      d=-r_one/dcmplx( pf2-fmass**2,max(sign(fmass*fwidth,pf2),r_zero))
      sl1= (vc(1)+       vc(4))*fo(3)
     &    +(vc(2)+c_imag*vc(3))*fo(4)
      sl2= (vc(2)-c_imag*vc(3))*fo(3)
     &    +(vc(1)-       vc(4))*fo(4)
c
      if ( g(2) .ne. r_zero ) then
         sr1= (vc(1)-       vc(4))*fo(1)
     &       -(vc(2)+c_imag*vc(3))*fo(2)
         sr2=-(vc(2)-c_imag*vc(3))*fo(1)
     &       +(vc(1)+       vc(4))*fo(2)
c
         fvo(1) = ( g(2)*( (pf(0)+pf(3))*sr1        +fvo(6)*sr2)
     &             +g(1)*fmass*sl1)*d
         fvo(2) = ( g(2)*( dconjg(fvo(6))*sr1 +(pf(0)-pf(3))*sr2)
     &             +g(1)*fmass*sl2)*d
         fvo(3) = ( g(1)*( (pf(0)-pf(3))*sl1        -fvo(6)*sl2)
     &             +g(2)*fmass*sr1)*d
         fvo(4) = ( g(1)*(-dconjg(fvo(6))*sl1 +(pf(0)+pf(3))*sl2)
     &             +g(2)*fmass*sr2)*d
c
      else
         fvo(1) = g(1)*fmass*sl1*d
         fvo(2) = g(1)*fmass*sl2*d
         fvo(3) = g(1)*( (pf(0)-pf(3))*sl1        -fvo(6)*sl2)*d
         fvo(4) = g(1)*(-dconjg(fvo(6))*sl1 +(pf(0)+pf(3))*sl2)*d
      end if
c
      return
      end
      subroutine iovxxx(fi,fo,vc,g , vertex)
C ----------------------------------------------------------------------
c
c this subroutine computes an amplitude of the fermion-fermion-vector
c coupling.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       complex vc(6)          : input    vector                      v
c       real    g(2)           : coupling constants                  gvf
c
c output:
c       complex vertex         : amplitude                     <fo|v|fi>
C ----------------------------------------------------------------------
c
      complex*16 fi(6),fo(6),vc(6),vertex
      real*8    g(2)
c
      real*8 r_zero, r_one
      parameter( r_zero=0.0d0, r_one=1.0d0 )
      complex*16 c_imag
C ----------------------------------------------------------------------
      c_imag=dcmplx( 0.d0, 1.d0 )
c
 
      vertex =  g(1)*( (fo(3)*fi(1)+fo(4)*fi(2))*vc(1)
     &                +(fo(3)*fi(2)+fo(4)*fi(1))*vc(2)
     &                -(fo(3)*fi(2)-fo(4)*fi(1))*vc(3)*c_imag
     &                +(fo(3)*fi(1)-fo(4)*fi(2))*vc(4)        )
c
      if ( g(2) .ne. r_zero ) then
         vertex = vertex
     &          + g(2)*( (fo(1)*fi(3)+fo(2)*fi(4))*vc(1)
     &                  -(fo(1)*fi(4)+fo(2)*fi(3))*vc(2)
     &                  +(fo(1)*fi(4)-fo(2)*fi(3))*vc(3)*c_imag
     &                  -(fo(1)*fi(3)-fo(2)*fi(4))*vc(4)        )
      end if
c
      return
      end
      subroutine ixxxxx(
     &              p,          !in: four vector momentum
     &              fmass,      !in: fermion mass
     &              nhel,       !in: spinor helicity, -1 or 1
     &              nsf,        !in: -1=antifermion, 1=fermion
     &              fi          !out: fermion wavefunction
     &                 )
C ----------------------------------------------------------------------
c
c       Subroutine returns the desired fermion or
c       anti-fermion spinor. ie., |f>
c       A replacement for the HELAS routine IXXXXX
c
c       Adam Duff,  1992 August 31
c       <duff@phenom.physics.wisc.edu>
C ----------------------------------------------------------------------
c
      implicit none
c
c declare input/output variables
c
      complex*16 fi(6)
      integer*4 nhel, nsf
      real*8 p(0:3), fmass
c
c declare local variables
c
      real*8 r_zero, r_one, r_two
      complex*16 c_zero
c
      real*8 plat, pabs, omegap, omegam, rs2pa, spaz
      parameter( r_zero=0.0d0, r_one=1.0d0, r_two=2.0d0 )
C ----------------------------------------------------------------------
      c_zero=dcmplx( 0.d0, 0.d0 )
c
c define kinematic parameters
c
      fi(5) = dcmplx( p(0), p(3) ) * nsf
      fi(6) = dcmplx( p(1), p(2) ) * nsf
      plat = sqrt( p(1)**2 + p(2)**2 )
      pabs = sqrt( p(1)**2 + p(2)**2 + p(3)**2 )
      omegap = sqrt( p(0) + pabs )
c
c do massive fermion case
c
      if ( fmass .ne. r_zero ) then
         omegam = fmass / omegap
         if ( nsf .eq. 1 ) then
            if ( nhel .eq. 1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fi(1) = dcmplx( omegam, r_zero )
                     fi(2) = c_zero
                     fi(3) = dcmplx( omegap, r_zero )
                     fi(4) = c_zero
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs + p(3) )
                     fi(1) = omegam * rs2pa
     &                     * dcmplx( spaz, r_zero )
                     fi(2) = omegam * rs2pa / spaz
     &                     * dcmplx( p(1), p(2) )
                     fi(3) = omegap * rs2pa
     &                     * dcmplx( spaz, r_zero )
                     fi(4) = omegap * rs2pa / spaz
     &                     * dcmplx( p(1), p(2) )
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fi(1) = c_zero
                     fi(2) = dcmplx( omegam, r_zero )
                     fi(3) = c_zero
                     fi(4) = dcmplx( omegap, r_zero )
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs - p(3) )
                     fi(1) = omegam * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                     fi(2) = omegam * rs2pa * spaz / plat
     &                     * dcmplx( p(1), p(2) )
                     fi(3) = omegap * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                     fi(4) = omegap * rs2pa * spaz / plat
     &                     * dcmplx( p(1), p(2) )
                  end if
               end if
            else if ( nhel .eq. -1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fi(1) = c_zero
                     fi(2) = dcmplx( omegap, r_zero )
                     fi(3) = c_zero
                     fi(4) = dcmplx( omegam, r_zero )
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs + p(3) )
                     fi(1) = omegap * rs2pa / spaz
     &                     * dcmplx( -p(1), p(2) )
                     fi(2) = omegap * rs2pa
     &                     * dcmplx( spaz, r_zero )
                     fi(3) = omegam * rs2pa / spaz
     &                     * dcmplx( -p(1), p(2) )
                     fi(4) = omegam * rs2pa
     &                     * dcmplx( spaz, r_zero )
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fi(1) = dcmplx( -omegap, r_zero )
                     fi(2) = c_zero
                     fi(3) = dcmplx( -omegam, r_zero )
                     fi(4) = c_zero
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs - p(3) )
                     fi(1) = omegap * rs2pa * spaz / plat
     &                     * dcmplx( -p(1), p(2) )
                     fi(2) = omegap * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                     fi(3) = omegam * rs2pa * spaz / plat
     &                     * dcmplx( -p(1), p(2) )
                     fi(4) = omegam * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                  end if
               end if
            else
               stop 'ixxxxx:  fermion helicity must be +1,-1'
            end if
         else if ( nsf .eq. -1 ) then
            if ( nhel .eq. 1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fi(1) = c_zero
                     fi(2) = dcmplx( -omegap, r_zero )
                     fi(3) = c_zero
                     fi(4) = dcmplx( omegam, r_zero )
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs + p(3) )
                     fi(1) = -omegap * rs2pa / spaz
     &                     * dcmplx( -p(1), p(2) )
                     fi(2) = -omegap * rs2pa
     &                     * dcmplx( spaz, r_zero )
                     fi(3) = omegam * rs2pa / spaz
     &                     * dcmplx( -p(1), p(2) )
                     fi(4) = omegam * rs2pa
     &                     * dcmplx( spaz, r_zero )
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fi(1) = dcmplx( omegap, r_zero )
                     fi(2) = c_zero
                     fi(3) = dcmplx( -omegam, r_zero )
                     fi(4) = c_zero
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs - p(3) )
                     fi(1) = -omegap * rs2pa * spaz / plat
     &                     * dcmplx( -p(1), p(2) )
                     fi(2) = -omegap * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                     fi(3) = omegam * rs2pa * spaz / plat
     &                     * dcmplx( -p(1), p(2) )
                     fi(4) = omegam * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                  end if
               end if
            else if ( nhel .eq. -1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fi(1) = dcmplx( omegam, r_zero )
                     fi(2) = c_zero
                     fi(3) = dcmplx( -omegap, r_zero )
                     fi(4) = c_zero
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs + p(3) )
                     fi(1) = omegam * rs2pa
     &                     * dcmplx( spaz, r_zero )
                     fi(2) = omegam * rs2pa / spaz
     &                     * dcmplx( p(1), p(2) )
                     fi(3) = -omegap * rs2pa
     &                     * dcmplx( spaz, r_zero )
                     fi(4) = -omegap * rs2pa / spaz
     &                     * dcmplx( p(1), p(2) )
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fi(1) = c_zero
                     fi(2) = dcmplx( omegam, r_zero )
                     fi(3) = c_zero
                     fi(4) = dcmplx( -omegap, r_zero )
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs - p(3) )
                     fi(1) = omegam * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                     fi(2) = omegam * rs2pa * spaz / plat
     &                     * dcmplx( p(1), p(2) )
                     fi(3) = -omegap * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                     fi(4) = -omegap * rs2pa * spaz / plat
     &                     * dcmplx( p(1), p(2) )
                  end if
               end if
            else
               stop 'ixxxxx:  fermion helicity must be +1,-1'
            end if
         else
            stop 'ixxxxx:  fermion type must be +1,-1'
         end if
c
c do massless fermion case
c
      else
         if ( nsf .eq. 1 ) then
            if ( nhel .eq. 1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fi(1) = c_zero
                     fi(2) = c_zero
                     fi(3) = dcmplx( omegap, r_zero )
                     fi(4) = c_zero
                  else
                     spaz = sqrt( pabs + p(3) )
                     fi(1) = c_zero
                     fi(2) = c_zero
                     fi(3) = dcmplx( spaz, r_zero )
                     fi(4) = r_one / spaz
     &                     * dcmplx( p(1), p(2) )
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fi(1) = c_zero
                     fi(2) = c_zero
                     fi(3) = c_zero
                     fi(4) = dcmplx( omegap, r_zero )
                  else
                     spaz = sqrt( pabs - p(3) )
                     fi(1) = c_zero
                     fi(2) = c_zero
                     fi(3) = r_one / spaz
     &                     * dcmplx( plat, r_zero )
                     fi(4) = spaz / plat
     &                     * dcmplx( p(1), p(2) )
                  end if
               end if
            else if ( nhel .eq. -1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fi(1) = c_zero
                     fi(2) = dcmplx( omegap, r_zero )
                     fi(3) = c_zero
                     fi(4) = c_zero
                  else
                     spaz = sqrt( pabs + p(3) )
                     fi(1) = r_one / spaz
     &                     * dcmplx( -p(1), p(2) )
                     fi(2) = dcmplx( spaz, r_zero )
                     fi(3) = c_zero
                     fi(4) = c_zero
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fi(1) = dcmplx( -omegap, r_zero )
                     fi(2) = c_zero
                     fi(3) = c_zero
                     fi(4) = c_zero
                  else
                     spaz = sqrt( pabs - p(3) )
                     fi(1) = spaz / plat
     &                     * dcmplx( -p(1), p(2) )
                     fi(2) = r_one / spaz
     &                     * dcmplx( plat, r_zero )
                     fi(3) = c_zero
                     fi(4) = c_zero
                  end if
               end if
            else
               stop 'ixxxxx:  fermion helicity must be +1,-1'
            end if
         else if ( nsf .eq. -1 ) then
            if ( nhel .eq. 1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fi(1) = c_zero
                     fi(2) = dcmplx( -omegap, r_zero )
                     fi(3) = c_zero
                     fi(4) = c_zero
                  else
                     spaz = sqrt( pabs + p(3) )
                     fi(1) = -r_one / spaz
     &                     * dcmplx( -p(1), p(2) )
                     fi(2) = dcmplx( -spaz, r_zero )
                     fi(3) = c_zero
                     fi(4) = c_zero
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fi(1) = dcmplx( omegap, r_zero )
                     fi(2) = c_zero
                     fi(3) = c_zero
                     fi(4) = c_zero
                  else
                     spaz = sqrt( pabs - p(3) )
                     fi(1) = -spaz / plat
     &                     * dcmplx( -p(1), p(2) )
                     fi(2) = -r_one / spaz
     &                     * dcmplx( plat, r_zero )
                     fi(3) = c_zero
                     fi(4) = c_zero
                  end if
               end if
            else if ( nhel .eq. -1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fi(1) = c_zero
                     fi(2) = c_zero
                     fi(3) = dcmplx( -omegap, r_zero )
                     fi(4) = c_zero
                  else
                     spaz = sqrt( pabs + p(3) )
                     fi(1) = c_zero
                     fi(2) = c_zero
                     fi(3) = dcmplx( -spaz, r_zero )
                     fi(4) = -r_one / spaz
     &                     * dcmplx( p(1), p(2) )
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fi(1) = c_zero
                     fi(2) = c_zero
                     fi(3) = c_zero
                     fi(4) = dcmplx( -omegap, r_zero )
                  else
                     spaz = sqrt( pabs - p(3) )
                     fi(1) = c_zero
                     fi(2) = c_zero
                     fi(3) = -r_one / spaz
     &                     * dcmplx( plat, r_zero )
                     fi(4) = -spaz / plat
     &                     * dcmplx( p(1), p(2) )
                  end if
               end if
            else
               stop 'ixxxxx:  fermion helicity must be +1,-1'
            end if
         else
            stop 'ixxxxx:  fermion type must be +1,-1'
         end if
      end if
c
c done
c
      return
      end
      subroutine jioxxx(fi,fo,g,vmass,vwidth , jio)
C ----------------------------------------------------------------------
c
c this subroutine computes an off-shell vector current from an external
c fermion pair.  the vector boson propagator is given in feynman gauge
c for a massless vector and in unitary gauge for a massive vector.
c
c input:
c       complex fi(6)          : flow-in  fermion                   |fi>
c       complex fo(6)          : flow-out fermion                   <fo|
c       real    g(2)           : coupling constants                  gvf
c       real    vmass          : mass  of output vector v
c       real    vwidth         : width of output vector v
c
c output:
c       complex jio(6)         : vector current          j^mu(<fo|v|fi>)
C ----------------------------------------------------------------------
c
      complex*16 fi(6),fo(6),jio(6),c0,c1,c2,c3,cs,d
      real*8    g(2),q(0:3),vmass,vwidth,q2,vm2,dd
c
      real*8 r_zero, r_one
      parameter( r_zero=0.0d0, r_one=1.0d0 )
      complex*16 c_imag
C ----------------------------------------------------------------------
      c_imag=dcmplx( 0.d0, 1.d0 )
c
      jio(5) = fo(5)-fi(5)
      jio(6) = fo(6)-fi(6)
c
      q(0)=dble( jio(5))
      q(1)=dble( jio(6))
      q(2)=dimag(jio(6))
      q(3)=dimag(jio(5))
      q2=q(0)**2-(q(1)**2+q(2)**2+q(3)**2)
      vm2=vmass**2
c
      if (vmass.ne.r_zero) then
c
         d=r_one/dcmplx( q2-vm2 , max(sign( vmass*vwidth ,q2),r_zero) )
c  for the running width, use below instead of the above d.
c      d=r_one/dcmplx( q2-vm2 , max( vwidth*q2/vmass ,r_zero) )
c
         if (g(2).ne.r_zero) then
c
            c0=  g(1)*( fo(3)*fi(1)+fo(4)*fi(2))
     &          +g(2)*( fo(1)*fi(3)+fo(2)*fi(4))
            c1= -g(1)*( fo(3)*fi(2)+fo(4)*fi(1))
     &          +g(2)*( fo(1)*fi(4)+fo(2)*fi(3))
            c2=( g(1)*( fo(3)*fi(2)-fo(4)*fi(1))
     &          +g(2)*(-fo(1)*fi(4)+fo(2)*fi(3)))*c_imag
            c3=  g(1)*(-fo(3)*fi(1)+fo(4)*fi(2))
     &          +g(2)*( fo(1)*fi(3)-fo(2)*fi(4))
         else
c
            d=d*g(1)
            c0=  fo(3)*fi(1)+fo(4)*fi(2)
            c1= -fo(3)*fi(2)-fo(4)*fi(1)
            c2=( fo(3)*fi(2)-fo(4)*fi(1))*c_imag
            c3= -fo(3)*fi(1)+fo(4)*fi(2)
         end if
c
         cs=(q(0)*c0-q(1)*c1-q(2)*c2-q(3)*c3)/vm2
c
         jio(1) = (c0-cs*q(0))*d
         jio(2) = (c1-cs*q(1))*d
         jio(3) = (c2-cs*q(2))*d
         jio(4) = (c3-cs*q(3))*d
c
      else
         dd=r_one/q2
c
         if (g(2).ne.r_zero) then
            jio(1) = ( g(1)*( fo(3)*fi(1)+fo(4)*fi(2))
     &                +g(2)*( fo(1)*fi(3)+fo(2)*fi(4)) )*dd
            jio(2) = (-g(1)*( fo(3)*fi(2)+fo(4)*fi(1))
     &                +g(2)*( fo(1)*fi(4)+fo(2)*fi(3)) )*dd
            jio(3) = ( g(1)*( fo(3)*fi(2)-fo(4)*fi(1))
     &                +g(2)*(-fo(1)*fi(4)+fo(2)*fi(3)))
     $           *dcmplx(r_zero,dd)
            jio(4) = ( g(1)*(-fo(3)*fi(1)+fo(4)*fi(2))
     &                +g(2)*( fo(1)*fi(3)-fo(2)*fi(4)) )*dd
c
         else
            dd=dd*g(1)
c
            jio(1) =  ( fo(3)*fi(1)+fo(4)*fi(2))*dd
            jio(2) = -( fo(3)*fi(2)+fo(4)*fi(1))*dd
            jio(3) =  ( fo(3)*fi(2)-fo(4)*fi(1))*dcmplx(r_zero,dd)
            jio(4) =  (-fo(3)*fi(1)+fo(4)*fi(2))*dd
         end if
      end if
c
      return
      end
      subroutine oxxxxx(
     &              p,          !in: four vector momentum
     &              fmass,      !in: fermion mass
     &              nhel,       !in: anti-spinor helicity, -1 or 1
     &              nsf,        !in: -1=antifermion, 1=fermion
     &              fo          !out: fermion wavefunction
     &                 )
C ----------------------------------------------------------------------
c
c       Subroutine returns the desired fermion or
c       anti-fermion anti-spinor. ie., <f|
c       A replacement for the HELAS routine OXXXXX
c
c       Adam Duff,  1992 August 31
c       <duff@phenom.physics.wisc.edu>
c
C ----------------------------------------------------------------------
      implicit none
c
c declare input/output variables
c
      complex*16 fo(6)
      integer*4 nhel, nsf
      real*8 p(0:3), fmass
c
c declare local variables
c
      real*8 r_zero, r_one, r_two
      complex*16 c_zero
      parameter( r_zero=0.0d0, r_one=1.0d0, r_two=2.0d0 )
c
      real*8 plat, pabs, omegap, omegam, rs2pa, spaz
C ----------------------------------------------------------------------
      c_zero=dcmplx( 0.d0, 0.d0 )
c
c define kinematic parameters
c
      fo(5) = dcmplx( p(0), p(3) ) * nsf
      fo(6) = dcmplx( p(1), p(2) ) * nsf
      plat = sqrt( p(1)**2 + p(2)**2 )
      pabs = sqrt( p(1)**2 + p(2)**2 + p(3)**2 )
      omegap = sqrt( p(0) + pabs )
c
c do massive fermion case
c
      if ( fmass .ne. r_zero ) then
         omegam = fmass / omegap
         if ( nsf .eq. 1 ) then
            if ( nhel .eq. 1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fo(1) = dcmplx( omegap, r_zero )
                     fo(2) = c_zero
                     fo(3) = dcmplx( omegam, r_zero )
                     fo(4) = c_zero
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs + p(3) )
                     fo(1) = omegap * rs2pa
     &                     * dcmplx( spaz, r_zero )
                     fo(2) = omegap * rs2pa / spaz
     &                     * dcmplx( p(1), -p(2) )
                     fo(3) = omegam * rs2pa
     &                     * dcmplx( spaz, r_zero )
                     fo(4) = omegam * rs2pa / spaz
     &                     * dcmplx( p(1), -p(2) )
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fo(1) = c_zero
                     fo(2) = dcmplx( omegap, r_zero )
                     fo(3) = c_zero
                     fo(4) = dcmplx( omegam, r_zero )
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs - p(3) )
                     fo(1) = omegap * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                     fo(2) = omegap * rs2pa * spaz / plat
     &                     * dcmplx( p(1), -p(2) )
                     fo(3) = omegam * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                     fo(4) = omegam * rs2pa * spaz / plat
     &                     * dcmplx( p(1), -p(2) )
                  end if
               end if
            else if ( nhel .eq. -1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fo(1) = c_zero
                     fo(2) = dcmplx( omegam, r_zero )
                     fo(3) = c_zero
                     fo(4) = dcmplx( omegap, r_zero )
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs + p(3) )
                     fo(1) = omegam * rs2pa / spaz
     &                     * dcmplx( -p(1), -p(2) )
                     fo(2) = omegam * rs2pa
     &                     * dcmplx( spaz, r_zero )
                     fo(3) = omegap * rs2pa / spaz
     &                     * dcmplx( -p(1), -p(2) )
                     fo(4) = omegap * rs2pa
     &                     * dcmplx( spaz, r_zero )
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fo(1) = dcmplx( -omegam, r_zero )
                     fo(2) = c_zero
                     fo(3) = dcmplx( -omegap, r_zero )
                     fo(4) = c_zero
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs - p(3) )
                     fo(1) = omegam * rs2pa * spaz / plat
     &                     * dcmplx( -p(1), -p(2) )
                     fo(2) = omegam * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                     fo(3) = omegap * rs2pa * spaz / plat
     &                     * dcmplx( -p(1), -p(2) )
                     fo(4) = omegap * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                  end if
               end if
            else
               stop 'oxxxxx:  fermion helicity must be +1,-1'
            end if
         else if ( nsf .eq. -1 ) then
            if ( nhel .eq. 1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fo(1) = c_zero
                     fo(2) = dcmplx( omegam, r_zero )
                     fo(3) = c_zero
                     fo(4) = dcmplx( -omegap, r_zero )
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs + p(3) )
                     fo(1) = omegam * rs2pa / spaz
     &                     * dcmplx( -p(1), -p(2) )
                     fo(2) = omegam * rs2pa
     &                     * dcmplx( spaz, r_zero )
                     fo(3) = -omegap * rs2pa / spaz
     &                     * dcmplx( -p(1), -p(2) )
                     fo(4) = -omegap * rs2pa
     &                     * dcmplx( spaz, r_zero )
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fo(1) = dcmplx( -omegam, r_zero )
                     fo(2) = c_zero
                     fo(3) = dcmplx( omegap, r_zero )
                     fo(4) = c_zero
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs - p(3) )
                     fo(1) = omegam * rs2pa * spaz / plat
     &                     * dcmplx( -p(1), -p(2) )
                     fo(2) = omegam * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                     fo(3) = -omegap * rs2pa * spaz / plat
     &                     * dcmplx( -p(1), -p(2) )
                     fo(4) = -omegap * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                  end if
               end if
            else if ( nhel .eq. -1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fo(1) = dcmplx( -omegap, r_zero )
                     fo(2) = c_zero
                     fo(3) = dcmplx( omegam, r_zero )
                     fo(4) = c_zero
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs + p(3) )
                     fo(1) = -omegap * rs2pa
     &                     * dcmplx( spaz, r_zero )
                     fo(2) = -omegap * rs2pa / spaz
     &                     * dcmplx( p(1), -p(2) )
                     fo(3) = omegam * rs2pa
     &                     * dcmplx( spaz, r_zero )
                     fo(4) = omegam * rs2pa / spaz
     &                     * dcmplx( p(1), -p(2) )
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fo(1) = c_zero
                     fo(2) = dcmplx( -omegap, r_zero )
                     fo(3) = c_zero
                     fo(4) = dcmplx( omegam, r_zero )
                  else
                     rs2pa = r_one / sqrt( r_two * pabs )
                     spaz = sqrt( pabs - p(3) )
                     fo(1) = -omegap * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                     fo(2) = -omegap * rs2pa * spaz / plat
     &                     * dcmplx( p(1), -p(2) )
                     fo(3) = omegam * rs2pa / spaz
     &                     * dcmplx( plat, r_zero )
                     fo(4) = omegam * rs2pa * spaz / plat
     &                     * dcmplx( p(1), -p(2) )
                  end if
               end if
            else
               stop 'oxxxxx:  fermion helicity must be +1,-1'
            end if
         else
            stop 'oxxxxx:  fermion type must be +1,-1'
         end if
c
c do massless case
c
      else
         if ( nsf .eq. 1 ) then
            if ( nhel .eq. 1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fo(1) = dcmplx( omegap, r_zero )
                     fo(2) = c_zero
                     fo(3) = c_zero
                     fo(4) = c_zero
                  else
                     spaz = sqrt( pabs + p(3) )
                     fo(1) = dcmplx( spaz, r_zero )
                     fo(2) = r_one / spaz
     &                     * dcmplx( p(1), -p(2) )
                     fo(3) = c_zero
                     fo(4) = c_zero
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fo(1) = c_zero
                     fo(2) = dcmplx( omegap, r_zero )
                     fo(3) = c_zero
                     fo(4) = c_zero
                  else
                     spaz = sqrt( pabs - p(3) )
                     fo(1) = r_one / spaz
     &                     * dcmplx( plat, r_zero )
                     fo(2) = spaz / plat
     &                     * dcmplx( p(1), -p(2) )
                     fo(3) = c_zero
                     fo(4) = c_zero
                  end if
               end if
            else if ( nhel .eq. -1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fo(1) = c_zero
                     fo(2) = c_zero
                     fo(3) = c_zero
                     fo(4) = dcmplx( omegap, r_zero )
                  else
                     spaz = sqrt( pabs + p(3) )
                     fo(1) = c_zero
                     fo(2) = c_zero
                     fo(3) = r_one / spaz
     &                     * dcmplx( -p(1), -p(2) )
                     fo(4) = dcmplx( spaz, r_zero )
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fo(1) = c_zero
                     fo(2) = c_zero
                     fo(3) = dcmplx( -omegap, r_zero )
                     fo(4) = c_zero
                  else
                     spaz = sqrt( pabs - p(3) )
                     fo(1) = c_zero
                     fo(2) = c_zero
                     fo(3) = spaz / plat
     &                     * dcmplx( -p(1), -p(2) )
                     fo(4) = r_one / spaz
     &                     * dcmplx( plat, r_zero )
                  end if
               end if
            else
               stop 'oxxxxx:  fermion helicity must be +1,-1'
            end if
         else if ( nsf .eq. -1 ) then
            if ( nhel .eq. 1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fo(1) = c_zero
                     fo(2) = c_zero
                     fo(3) = c_zero
                     fo(4) = dcmplx( -omegap, r_zero )
                  else
                     spaz = sqrt( pabs + p(3) )
                     fo(1) = c_zero
                     fo(2) = c_zero
                     fo(3) = -r_one / spaz
     &                     * dcmplx( -p(1), -p(2) )
                     fo(4) = dcmplx( -spaz, r_zero )
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fo(1) = c_zero
                     fo(2) = c_zero
                     fo(3) = dcmplx( omegap, r_zero )
                     fo(4) = c_zero
                  else
                     spaz = sqrt( pabs - p(3) )
                     fo(1) = c_zero
                     fo(2) = c_zero
                     fo(3) = -spaz / plat
     &                     * dcmplx( -p(1), -p(2) )
                     fo(4) = -r_one / spaz
     &                     * dcmplx( plat, r_zero )
                  end if
               end if
            else if ( nhel .eq. -1 ) then
               if ( p(3) .ge. r_zero ) then
                  if ( plat .eq. r_zero ) then
                     fo(1) = dcmplx( -omegap, r_zero )
                     fo(2) = c_zero
                     fo(3) = c_zero
                     fo(4) = c_zero
                  else
                     spaz = sqrt( pabs + p(3) )
                     fo(1) = dcmplx( -spaz, r_zero )
                     fo(2) = -r_one / spaz
     &                     * dcmplx( p(1), -p(2) )
                     fo(3) = c_zero
                     fo(4) = c_zero
                  end if
               else
                  if ( plat .eq. r_zero ) then
                     fo(1) = c_zero
                     fo(2) = dcmplx( -omegap, r_zero )
                     fo(3) = c_zero
                     fo(4) = c_zero
                  else
                     spaz = sqrt( pabs - p(3) )
                     fo(1) = -r_one / spaz
     &                     * dcmplx( plat, r_zero )
                     fo(2) = -spaz / plat
     &                     * dcmplx( p(1), -p(2) )
                     fo(3) = c_zero
                     fo(4) = c_zero
                  end if
               end if
            else
               stop 'oxxxxx:  fermion helicity must be +1,-1'
            end if
         else
            stop 'oxxxxx:  fermion type must be +1,-1'
         end if
      end if
c
c done
c
      return
      end
      SUBROUTINE SEPEM_VEVEA(P1, P2, P3, P4, P5, S1)
C ----------------------------------------------------------------------
C MODIFIED 22.06.96 TO CALCULATE S1 FOR A SET OF ANOMALOUS
C      COUPLINGS
C
C FUNCTION GENERATED BY MADGRAPH
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P1,P2,P3,P4,...
C
C FOR PROCESS : e+ e-  -> ve ve~ a
C ----------------------------------------------------------------------
C
      IMPLICIT NONE
C
C CONSTANTS
C
      INTEGER    NEXTERNAL,   NCOMB
      PARAMETER (NEXTERNAL=5, NCOMB= 32)
C
C ARGUMENTS
C
      REAL*8 P1(0:3),P2(0:3),P3(0:3),P4(0:3),P5(0:3)
 
 
C DODALEM --------------------->
C OUTPUT S1(6)
      REAL*8 S1(6) ,T(6)
      INTEGER ICASE
C------------------------------<
C
C LOCAL VARIABLES
C
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      INTEGER IHEL
      LOGICAL GOODHEL(NCOMB)
      DATA GOODHEL/NCOMB*.FALSE./
      DATA NTRY/0/
      DATA (NHEL(IHEL,  1),IHEL=1,5) / -1, -1, -1, -1, -1/
      DATA (NHEL(IHEL,  2),IHEL=1,5) / -1, -1, -1, -1,  1/
      DATA (NHEL(IHEL,  3),IHEL=1,5) / -1, -1, -1,  1, -1/
      DATA (NHEL(IHEL,  4),IHEL=1,5) / -1, -1, -1,  1,  1/
      DATA (NHEL(IHEL,  5),IHEL=1,5) / -1, -1,  1, -1, -1/
      DATA (NHEL(IHEL,  6),IHEL=1,5) / -1, -1,  1, -1,  1/
      DATA (NHEL(IHEL,  7),IHEL=1,5) / -1, -1,  1,  1, -1/
      DATA (NHEL(IHEL,  8),IHEL=1,5) / -1, -1,  1,  1,  1/
      DATA (NHEL(IHEL,  9),IHEL=1,5) / -1,  1, -1, -1, -1/
      DATA (NHEL(IHEL, 10),IHEL=1,5) / -1,  1, -1, -1,  1/
      DATA (NHEL(IHEL, 11),IHEL=1,5) / -1,  1, -1,  1, -1/
      DATA (NHEL(IHEL, 12),IHEL=1,5) / -1,  1, -1,  1,  1/
      DATA (NHEL(IHEL, 13),IHEL=1,5) / -1,  1,  1, -1, -1/
      DATA (NHEL(IHEL, 14),IHEL=1,5) / -1,  1,  1, -1,  1/
      DATA (NHEL(IHEL, 15),IHEL=1,5) / -1,  1,  1,  1, -1/
      DATA (NHEL(IHEL, 16),IHEL=1,5) / -1,  1,  1,  1,  1/
      DATA (NHEL(IHEL, 17),IHEL=1,5) /  1, -1, -1, -1, -1/
      DATA (NHEL(IHEL, 18),IHEL=1,5) /  1, -1, -1, -1,  1/
      DATA (NHEL(IHEL, 19),IHEL=1,5) /  1, -1, -1,  1, -1/
      DATA (NHEL(IHEL, 20),IHEL=1,5) /  1, -1, -1,  1,  1/
      DATA (NHEL(IHEL, 21),IHEL=1,5) /  1, -1,  1, -1, -1/
      DATA (NHEL(IHEL, 22),IHEL=1,5) /  1, -1,  1, -1,  1/
      DATA (NHEL(IHEL, 23),IHEL=1,5) /  1, -1,  1,  1, -1/
      DATA (NHEL(IHEL, 24),IHEL=1,5) /  1, -1,  1,  1,  1/
      DATA (NHEL(IHEL, 25),IHEL=1,5) /  1,  1, -1, -1, -1/
      DATA (NHEL(IHEL, 26),IHEL=1,5) /  1,  1, -1, -1,  1/
      DATA (NHEL(IHEL, 27),IHEL=1,5) /  1,  1, -1,  1, -1/
      DATA (NHEL(IHEL, 28),IHEL=1,5) /  1,  1, -1,  1,  1/
      DATA (NHEL(IHEL, 29),IHEL=1,5) /  1,  1,  1, -1, -1/
      DATA (NHEL(IHEL, 30),IHEL=1,5) /  1,  1,  1, -1,  1/
      DATA (NHEL(IHEL, 31),IHEL=1,5) /  1,  1,  1,  1, -1/
      DATA (NHEL(IHEL, 32),IHEL=1,5) /  1,  1,  1,  1,  1/
C ----------------------------------------------------------------------
C ----------
C BEGIN CODE
C ----------
c      write(*,*)'wszedl do sepem'
        DO ICASE=1,6
           S1(ICASE) = 0d0
        ENDDO
      NTRY=NTRY+1
      DO IHEL=1,NCOMB
          IF (GOODHEL(IHEL) .OR. NTRY .LT. 10) THEN
             CALL EPEM_VEVEA(P1, P2, P3, P4, P5,T,NHEL(1,IHEL))
             DO ICASE=1,6
                   S1(ICASE) = S1(ICASE) + T(ICASE)
             ENDDO
                IF (T(1) .GT. 0D0 .AND. .NOT. GOODHEL(IHEL)) THEN
                  GOODHEL(IHEL)=.TRUE.
C                  WRITE(*,*) IHEL,T(1)
                ENDIF
          ENDIF
        ENDDO
        DO ICASE=1,6
           S1(ICASE) = S1(ICASE) /  4D0
        ENDDO
      END
      SUBROUTINE EPEM_VEVEA(P1, P2, P3, P4, P5,T,NHEL)
C ----------------------------------------------------------------------
C
C FUNCTION GENERATED BY MADGRAPH
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT IN PHASE SPACE P1,P2,P3,P4,...
C AND HELICITY NHEL(1),NHEL(2),....
C
C FOR PROCESS : e+ e-  -> ve ve~ a
C ----------------------------------------------------------------------
C
      IMPLICIT NONE
C
C CONSTANTS
C
      INTEGER    NGRAPHS,    NEIGEN,    NEXTERNAL
      PARAMETER (NGRAPHS=  5,NEIGEN=  1,NEXTERNAL=5)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C DODALEM   22.06.96 ------->
      REAL*8 T(6),EPEM
      INTEGER ICASE
      COMPLEX*16 ANOM(6)
C ONLY VVVXXX HAS ANOMALOUS COUPLINGS
C --------------------------<
C
C ARGUMENTS
C
      REAL*8 P1(0:3),P2(0:3),P3(0:3),P4(0:3),P5(0:3)
      INTEGER NHEL(NEXTERNAL)
C
C LOCAL VARIABLES
C
      INTEGER I,J
      REAL*8 EIGEN_VAL(NEIGEN), EIGEN_VEC(NGRAPHS,NEIGEN)
      COMPLEX*16 ZTEMP
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W1(6)  , W2(6)  , W3(6)  , W4(6)  , W5(6)
      COMPLEX*16 W6(6)  , W7(6)  , W8(6)  , W9(6)  , W10(6)
      COMPLEX*16 W11(6)
C
C GLOBAL VARIABLES
C
      REAL*8         GW, GWWA, GWWZ
      COMMON /COUP1/ GW, GWWA, GWWZ
      REAL*8         GAL(2),GAU(2),GAD(2),GWF(2)
      COMMON /COUP2A/GAL,   GAU,   GAD,   GWF
      REAL*8         GZN(2),GZL(2),GZU(2),GZD(2),G1(2)
      COMMON /COUP2B/GZN,   GZL,   GZU,   GZD,   G1
      REAL*8         GWWH,GZZH,GHHH,GWWHH,GZZHH,GHHHH
      COMMON /COUP3/ GWWH,GZZH,GHHH,GWWHH,GZZHH,GHHHH
      COMPLEX*16     GH(2,12)
      COMMON /COUP4/ GH
      REAL*8         WMASS,WWIDTH,ZMASS,ZWIDTH
      COMMON /VMASS1/WMASS,WWIDTH,ZMASS,ZWIDTH
      REAL*8         AMASS,AWIDTH,HMASS,HWIDTH
      COMMON /VMASS2/AMASS,AWIDTH,HMASS,HWIDTH
      REAL*8            FMASS(12), FWIDTH(12)
      COMMON /FERMIONS/ FMASS,     FWIDTH
c ------- flags for turning off wwg diagram, 28.10.96
      integer nwwg,nneutr
      common/flags/nwwg,nneutr
C
C COLOR DATA
C
      DATA EIGEN_VAL(1  )/       5.0000000000000009D+00 /
      DATA EIGEN_VEC(1  ,1  )/  -4.4721359549995793D-01 /
      DATA EIGEN_VEC(2  ,1  )/  -4.4721359549995793D-01 /
      DATA EIGEN_VEC(3  ,1  )/  -4.4721359549995793D-01 /
      DATA EIGEN_VEC(4  ,1  )/   4.4721359549995793D-01 /
      DATA EIGEN_VEC(5  ,1  )/   4.4721359549995793D-01 /
C ----------------------------------------------------------------------
C ----------
C BEGIN CODE
C ----------
      do icase=1,6
      anom(icase)=0.d0
      enddo
      CALL OXXXXX(P1  ,FMASS(1  ),NHEL(1  ),-1,W1  )
      CALL IXXXXX(P2  ,FMASS(1  ),NHEL(2  ), 1,W2  )
      CALL OXXXXX(P3  ,FMASS(2  ),NHEL(3  ), 1,W3  )
      CALL IXXXXX(P4  ,FMASS(2  ),NHEL(4  ),-1,W4  )
      CALL VXXXXX(P5  , ZERO,NHEL(5  ), 1,W5  )
      CALL JIOXXX(W2  ,W3  ,GWF,WMASS,WWIDTH,W6  )
      CALL FVIXXX(W4  ,W6  ,GWF,FMASS(1  ),FWIDTH(1  ),W7  )
      CALL IOVXXX(W7  ,W1  ,W5  ,GAL,AMP(1  ))
      CALL JIOXXX(W4  ,W1  ,GWF,WMASS,WWIDTH,W8  )
      CALL FVIXXX(W2  ,W5  ,GAL,FMASS(1  ),FWIDTH(1  ),W9  )
      CALL IOVXXX(W9  ,W3  ,W8  ,GWF,AMP(2  ))
      if(nwwg.eq.1) CALL VVVXXX(W8  ,W6  ,W5  ,GWWA,ANOM)
      CALL JIOXXX(W4  ,W3  ,GZN,ZMASS,ZWIDTH,W10 )
      CALL FVOXXX(W1  ,W5  ,GAL,FMASS(1  ),FWIDTH(1  ),W11 )
      CALL IOVXXX(W2  ,W11 ,W10 ,GZL,AMP(4  ))
      CALL IOVXXX(W9  ,W1  ,W10 ,GZL,AMP(5  ))
C
      DO ICASE=1,6
        AMP(3)=ANOM(ICASE)
        EPEM = 0.D0
        DO I = 1, NEIGEN
          ZTEMP = (0.D0,0.D0)
          DO J = 1, NGRAPHS
              ZTEMP = ZTEMP + EIGEN_VEC(J,I)*AMP(J)
          ENDDO
          EPEM =EPEM+ZTEMP*EIGEN_VAL(I)*CONJG(ZTEMP)
        ENDDO
        T(ICASE)=EPEM
      ENDDO
C      CALL GAUGECHECK(AMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NGRAPHS,NEIGEN)
      RETURN
      END
      REAL*8 FUNCTION SEPEM_VMVMA(P1, P2, P3, P4, P5)
C ----------------------------------------------------------------------
C
C FUNCTION GENERATED BY MADGRAPH
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P1,P2,P3,P4,...
C
C FOR PROCESS : e+ e-  -> vm vm~ a
C ----------------------------------------------------------------------
C
      IMPLICIT NONE
C
C CONSTANTS
C
      INTEGER    NEXTERNAL,   NCOMB
      PARAMETER (NEXTERNAL=5, NCOMB= 32)
C
C ARGUMENTS
C
      REAL*8 P1(0:3),P2(0:3),P3(0:3),P4(0:3),P5(0:3)
C
C LOCAL VARIABLES
C
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      REAL*8 T
      REAL*8 EPEM_VMVMA
      INTEGER IHEL
      LOGICAL GOODHEL(NCOMB)
      DATA GOODHEL/NCOMB*.FALSE./
      DATA NTRY/0/
      DATA (NHEL(IHEL,  1),IHEL=1,5) / -1, -1, -1, -1, -1/
      DATA (NHEL(IHEL,  2),IHEL=1,5) / -1, -1, -1, -1,  1/
      DATA (NHEL(IHEL,  3),IHEL=1,5) / -1, -1, -1,  1, -1/
      DATA (NHEL(IHEL,  4),IHEL=1,5) / -1, -1, -1,  1,  1/
      DATA (NHEL(IHEL,  5),IHEL=1,5) / -1, -1,  1, -1, -1/
      DATA (NHEL(IHEL,  6),IHEL=1,5) / -1, -1,  1, -1,  1/
      DATA (NHEL(IHEL,  7),IHEL=1,5) / -1, -1,  1,  1, -1/
      DATA (NHEL(IHEL,  8),IHEL=1,5) / -1, -1,  1,  1,  1/
      DATA (NHEL(IHEL,  9),IHEL=1,5) / -1,  1, -1, -1, -1/
      DATA (NHEL(IHEL, 10),IHEL=1,5) / -1,  1, -1, -1,  1/
      DATA (NHEL(IHEL, 11),IHEL=1,5) / -1,  1, -1,  1, -1/
      DATA (NHEL(IHEL, 12),IHEL=1,5) / -1,  1, -1,  1,  1/
      DATA (NHEL(IHEL, 13),IHEL=1,5) / -1,  1,  1, -1, -1/
      DATA (NHEL(IHEL, 14),IHEL=1,5) / -1,  1,  1, -1,  1/
      DATA (NHEL(IHEL, 15),IHEL=1,5) / -1,  1,  1,  1, -1/
      DATA (NHEL(IHEL, 16),IHEL=1,5) / -1,  1,  1,  1,  1/
      DATA (NHEL(IHEL, 17),IHEL=1,5) /  1, -1, -1, -1, -1/
      DATA (NHEL(IHEL, 18),IHEL=1,5) /  1, -1, -1, -1,  1/
      DATA (NHEL(IHEL, 19),IHEL=1,5) /  1, -1, -1,  1, -1/
      DATA (NHEL(IHEL, 20),IHEL=1,5) /  1, -1, -1,  1,  1/
      DATA (NHEL(IHEL, 21),IHEL=1,5) /  1, -1,  1, -1, -1/
      DATA (NHEL(IHEL, 22),IHEL=1,5) /  1, -1,  1, -1,  1/
      DATA (NHEL(IHEL, 23),IHEL=1,5) /  1, -1,  1,  1, -1/
      DATA (NHEL(IHEL, 24),IHEL=1,5) /  1, -1,  1,  1,  1/
      DATA (NHEL(IHEL, 25),IHEL=1,5) /  1,  1, -1, -1, -1/
      DATA (NHEL(IHEL, 26),IHEL=1,5) /  1,  1, -1, -1,  1/
      DATA (NHEL(IHEL, 27),IHEL=1,5) /  1,  1, -1,  1, -1/
      DATA (NHEL(IHEL, 28),IHEL=1,5) /  1,  1, -1,  1,  1/
      DATA (NHEL(IHEL, 29),IHEL=1,5) /  1,  1,  1, -1, -1/
      DATA (NHEL(IHEL, 30),IHEL=1,5) /  1,  1,  1, -1,  1/
      DATA (NHEL(IHEL, 31),IHEL=1,5) /  1,  1,  1,  1, -1/
      DATA (NHEL(IHEL, 32),IHEL=1,5) /  1,  1,  1,  1,  1/
C ----------------------------------------------------------------------
C ----------
C BEGIN CODE
C ----------
      SEPEM_VMVMA = 0d0
      NTRY=NTRY+1
      DO IHEL=1,NCOMB
          IF (GOODHEL(IHEL) .OR. NTRY .LT. 10) THEN
             T=EPEM_VMVMA(P1, P2, P3, P4, P5,NHEL(1,IHEL))
             SEPEM_VMVMA = SEPEM_VMVMA + T
              IF (T .GT. 0D0 .AND. .NOT. GOODHEL(IHEL)) THEN
                  GOODHEL(IHEL)=.TRUE.
C                  WRITE(*,*) IHEL,T
              ENDIF
          ENDIF
      ENDDO
      SEPEM_VMVMA = SEPEM_VMVMA /  4D0
      END
      REAL*8 FUNCTION EPEM_VMVMA(P1, P2, P3, P4, P5,NHEL)
C ----------------------------------------------------------------------
C
C FUNCTION GENERATED BY MADGRAPH
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT IN PHASE SPACE P1,P2,P3,P4,...
C AND HELICITY NHEL(1),NHEL(2),....
C
C FOR PROCESS : e+ e-  -> vm vm~ a
C ----------------------------------------------------------------------
C
      IMPLICIT NONE
C
C CONSTANTS
C
      INTEGER    NGRAPHS,    NEIGEN,    NEXTERNAL
      PARAMETER (NGRAPHS=  2,NEIGEN=  1,NEXTERNAL=5)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
C
C ARGUMENTS
C
      REAL*8 P1(0:3),P2(0:3),P3(0:3),P4(0:3),P5(0:3)
      INTEGER NHEL(NEXTERNAL)
C
C LOCAL VARIABLES
C
      INTEGER I,J
      REAL*8 EIGEN_VAL(NEIGEN), EIGEN_VEC(NGRAPHS,NEIGEN)
      COMPLEX*16 ZTEMP
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W1(6)  , W2(6)  , W3(6)  , W4(6)  , W5(6)
      COMPLEX*16 W6(6)  , W7(6)  , W8(6)
C
C GLOBAL VARIABLES
C
      REAL*8         GW, GWWA, GWWZ
      COMMON /COUP1/ GW, GWWA, GWWZ
      REAL*8         GAL(2),GAU(2),GAD(2),GWF(2)
      COMMON /COUP2A/GAL,   GAU,   GAD,   GWF
      REAL*8         GZN(2),GZL(2),GZU(2),GZD(2),G1(2)
      COMMON /COUP2B/GZN,   GZL,   GZU,   GZD,   G1
      REAL*8         GWWH,GZZH,GHHH,GWWHH,GZZHH,GHHHH
      COMMON /COUP3/ GWWH,GZZH,GHHH,GWWHH,GZZHH,GHHHH
      COMPLEX*16     GH(2,12)
      COMMON /COUP4/ GH
      REAL*8         WMASS,WWIDTH,ZMASS,ZWIDTH
      COMMON /VMASS1/WMASS,WWIDTH,ZMASS,ZWIDTH
      REAL*8         AMASS,AWIDTH,HMASS,HWIDTH
      COMMON /VMASS2/AMASS,AWIDTH,HMASS,HWIDTH
      REAL*8            FMASS(12), FWIDTH(12)
      COMMON /FERMIONS/ FMASS,     FWIDTH
C
C COLOR DATA
C
      DATA EIGEN_VAL(1  )/       2.0000000000000004D+00 /
      DATA EIGEN_VEC(1  ,1  )/   7.0710678118654746D-01 /
      DATA EIGEN_VEC(2  ,1  )/   7.0710678118654746D-01 /
C ----------------------------------------------------------------------
C ----------
C BEGIN CODE
C ----------
      CALL OXXXXX(P1  ,FMASS(1  ),NHEL(1  ),-1,W1  )
      CALL IXXXXX(P2  ,FMASS(1  ),NHEL(2  ), 1,W2  )
      CALL OXXXXX(P3  ,FMASS(6  ),NHEL(3  ), 1,W3  )
      CALL IXXXXX(P4  ,FMASS(6  ),NHEL(4  ),-1,W4  )
      CALL VXXXXX(P5  , ZERO,NHEL(5  ), 1,W5  )
      CALL JIOXXX(W4  ,W3  ,GZN,ZMASS,ZWIDTH,W6  )
      CALL FVOXXX(W1  ,W5  ,GAL,FMASS(1  ),FWIDTH(1  ),W7  )
      CALL IOVXXX(W2  ,W7  ,W6  ,GZL,AMP(1  ))
      CALL FVIXXX(W2  ,W5  ,GAL,FMASS(1  ),FWIDTH(1  ),W8  )
      CALL IOVXXX(W8  ,W1  ,W6  ,GZL,AMP(2  ))
      EPEM_VMVMA = 0.D0
      DO I = 1, NEIGEN
          ZTEMP = (0.D0,0.D0)
          DO J = 1, NGRAPHS
              ZTEMP = ZTEMP + EIGEN_VEC(J,I)*AMP(J)
          ENDDO
          EPEM_VMVMA =EPEM_VMVMA+ZTEMP*EIGEN_VAL(I)*CONJG(ZTEMP)
      ENDDO
C      CALL GAUGECHECK(AMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NGRAPHS,NEIGEN)
      END
      subroutine vxxxxx(
     &              p,          !in: boson four momentum
     &              vmass,      !in: boson mass
     &              nhel,       !in: boson helicity
     &              nsv,        !in: incoming (-1) or outgoing (+1)
     &              vc          !out: boson wavefunction
     &                 )
C ----------------------------------------------------------------------
c
c       Subroutine returns the value of evaluated
c       helicity basis boson polarisation wavefunction.
c       Replaces the HELAS routine VXXXXX
c
c       Adam Duff,  1992 September 3
c       <duff@phenom.physics.wisc.edu>
c
C ----------------------------------------------------------------------
      implicit none
c
c declare input/output variables
c
      complex*16 vc(6)
      integer*4 nhel, nsv
      real*8 p(0:3), vmass
c
c declare local variables
c
      real*8 r_zero, r_one, r_two
      parameter( r_zero=0.0d0, r_one=1.0d0, r_two=2.0d0 )
      complex*16 c_zero
 
c
      real*8 plat, pabs, rs2, rplat, rpabs, rden
C ----------------------------------------------------------------------
      c_zero=dcmplx( r_zero, r_zero )
c define internal/external momenta
c
      if ( nsv**2 .ne. 1 ) then
         stop 'vxxxxx:  nsv is not one of -1, +1'
      end if
c
      rs2 = sqrt( r_one / r_two )
      vc(5) = dcmplx( p(0), p(3) ) * nsv
      vc(6) = dcmplx( p(1), p(2) ) * nsv
      plat = sqrt( p(1)**2 + p(2)**2 )
      pabs = sqrt( p(1)**2 + p(2)**2 + p(3)**2 )
c
c calculate polarisation four vectors
c
      if ( nhel**2 .eq. 1 ) then
         if ( (pabs .eq. r_zero) .or. (plat .eq. r_zero) ) then
            vc(1) = c_zero
            vc(2) = dcmplx( -nhel * rs2 * dsign( r_one, p(3) ), r_zero )
            vc(3) = dcmplx( r_zero, nsv * rs2 )
            vc(4) = c_zero
         else
            rplat = r_one / plat
            rpabs = r_one / pabs
            vc(1) = c_zero
            vc(2) = dcmplx( -nhel * rs2 * rpabs * rplat * p(1) * p(3),
     &                     -nsv * rs2 * rplat * p(2) )
            vc(3) = dcmplx( -nhel * rs2 * rpabs * rplat * p(2) * p(3),
     &                     nsv * rs2 * rplat * p(1) )
            vc(4) = dcmplx( nhel * rs2 * rpabs * plat,
     &                     r_zero )
         end if
      else if ( nhel .eq. 0 ) then
         if ( vmass .gt. r_zero ) then
            if ( pabs .eq. r_zero ) then
               vc(1) = c_zero
               vc(2) = c_zero
               vc(3) = c_zero
               vc(4) = dcmplx( r_one, r_zero )
            else
               rden = p(0) / ( vmass * pabs )
               vc(1) = dcmplx( pabs / vmass, r_zero )
               vc(2) = dcmplx( rden * p(1), r_zero )
               vc(3) = dcmplx( rden * p(2), r_zero )
               vc(4) = dcmplx( rden * p(3), r_zero )
            end if
         else
            stop  'vxxxxx: nhel = 0 is only for massive bosons'
         end if
      else if ( nhel .eq. 4 ) then
         if ( vmass .gt. r_zero ) then
            rden = r_one / vmass
            vc(1) = dcmplx( rden * p(0), r_zero )
            vc(2) = dcmplx( rden * p(1), r_zero )
            vc(3) = dcmplx( rden * p(2), r_zero )
            vc(4) = dcmplx( rden * p(3), r_zero )
         elseif (vmass .eq. r_zero) then
            rden = r_one / p(0)
            vc(1) = dcmplx( rden * p(0), r_zero )
            vc(2) = dcmplx( rden * p(1), r_zero )
            vc(3) = dcmplx( rden * p(2), r_zero )
            vc(4) = dcmplx( rden * p(3), r_zero )
         else
            stop 'vxxxxx: nhel = 4 is only for m>=0'
         end if
      else
         stop 'vxxxxx:  nhel is not one of -1, 0, 1 or 4'
      end if
c
c done
c
      return
      end
c
      subroutine vvvxxx(wm,wp,w3,g , vertex)
C ----------------------------------------------------------------------
c
c this subroutine computes an amplitude of the three-point coupling of
c the gauge bosons.
c
c input:
c       complex wm(6)          : vector               flow-out w-
c       complex wp(6)          : vector               flow-out w+
c       complex w3(6)          : vector               j3 or a    or z
c       real    g              : coupling constant    gw or gwwa or gwwz
c
c output:
c       complex vertex(6)      : amplitude               gamma(wm,wp,w3)
c
C ----------------------------------------------------------------------
      implicit none
      complex*16 wm(6),wp(6),w3(6),vertex(6),
     &        xv1,xv2,xv3,v12,v23,v31,p12,p13,p21,p23,p31,p32
      real*8    pwm(0:3),pwp(0:3),pw3(0:3),g
c
      real*8 r_zero, r_tenth
      real*8 delkappa, lambda, delg1, p_pmin, p_ppls, pmn_ppl, wmass
      real*8 delkappa0(6),lambda0(6)
      integer ic
      common/anom/delkappa0,lambda0
      parameter( r_zero=0.0d0, r_tenth=0.1d0 )
C ----------------------------------------------------------------------
      delg1=0.d0
      wmass=80.2d0
c
      pwm(0)=dble( wm(5))
      pwm(1)=dble( wm(6))
      pwm(2)=dimag(wm(6))
      pwm(3)=dimag(wm(5))
      pwp(0)=dble( wp(5))
      pwp(1)=dble( wp(6))
      pwp(2)=dimag(wp(6))
      pwp(3)=dimag(wp(5))
      pw3(0)=dble( w3(5))
      pw3(1)=dble( w3(6))
      pw3(2)=dimag(w3(6))
      pw3(3)=dimag(w3(5))
c
      v12=wm(1)*wp(1)-wm(2)*wp(2)-wm(3)*wp(3)-wm(4)*wp(4)
      v23=wp(1)*w3(1)-wp(2)*w3(2)-wp(3)*w3(3)-wp(4)*w3(4)
      v31=w3(1)*wm(1)-w3(2)*wm(2)-w3(3)*wm(3)-w3(4)*wm(4)
      xv1=r_zero
      xv2=r_zero
      xv3=r_zero
      if ( abs(wm(1)) .ne. r_zero ) then
         if (abs(wm(1)).ge.max(abs(wm(2)),abs(wm(3)),abs(wm(4)))
     $        *r_tenth)
     &      xv1=pwm(0)/wm(1)
      endif
      if ( abs(wp(1)) .ne. r_zero) then
         if (abs(wp(1)).ge.max(abs(wp(2)),abs(wp(3)),abs(wp(4)))
     $        *r_tenth)
     &      xv2=pwp(0)/wp(1)
      endif
      if ( abs(w3(1)) .ne. r_zero) then
         if ( abs(w3(1)).ge.max(abs(w3(2)),abs(w3(3)),abs(w3(4)))
     $        *r_tenth)
     &      xv3=pw3(0)/w3(1)
      endif
      p12= (pwm(0)-xv1*wm(1))*wp(1)-(pwm(1)-xv1*wm(2))*wp(2)
     &    -(pwm(2)-xv1*wm(3))*wp(3)-(pwm(3)-xv1*wm(4))*wp(4)
      p13= (pwm(0)-xv1*wm(1))*w3(1)-(pwm(1)-xv1*wm(2))*w3(2)
     &    -(pwm(2)-xv1*wm(3))*w3(3)-(pwm(3)-xv1*wm(4))*w3(4)
      p21= (pwp(0)-xv2*wp(1))*wm(1)-(pwp(1)-xv2*wp(2))*wm(2)
     &    -(pwp(2)-xv2*wp(3))*wm(3)-(pwp(3)-xv2*wp(4))*wm(4)
      p23= (pwp(0)-xv2*wp(1))*w3(1)-(pwp(1)-xv2*wp(2))*w3(2)
     &    -(pwp(2)-xv2*wp(3))*w3(3)-(pwp(3)-xv2*wp(4))*w3(4)
      p31= (pw3(0)-xv3*w3(1))*wm(1)-(pw3(1)-xv3*w3(2))*wm(2)
     &    -(pw3(2)-xv3*w3(3))*wm(3)-(pw3(3)-xv3*w3(4))*wm(4)
      p32= (pw3(0)-xv3*w3(1))*wp(1)-(pw3(1)-xv3*w3(2))*wp(2)
     &    -(pw3(2)-xv3*w3(3))*wp(3)-(pw3(3)-xv3*w3(4))*wp(4)
c
        p12=p12+xv1*v12
        p13=p13+xv1*v31
        p21=p21+xv2*v12
        p23=p23+xv2*v23
        p31=p31+xv3*v31
        p32=p32+xv3*v23
        p_pmin=pw3(0)*pwm(0)-pw3(1)*pwm(1)-pw3(2)*pwm(2)-pw3(3)*pwm(3)
        p_ppls=pw3(0)*pwp(0)-pw3(1)*pwp(1)-pw3(2)*pwp(2)-pw3(3)*pwp(3)
        pmn_ppl=pwp(0)*pwm(0)-pwp(1)*pwm(1)-pwp(2)*pwm(2)-pwp(3)*pwm(3)
        do ic=1,6
        delkappa=delkappa0(ic)
        lambda=lambda0(ic)
        vertex(ic) = -(v12*(p13-p23)+v23*(p21-p31)+v31*(p32-p12))*g
c
c anomalous contributions
c-----------------------------------------------------------
        if ((delkappa.ne.0.d0).or.(delg1.ne.0.d0).or.(lambda.ne.0.d0))
     +    then
          if (delkappa.ne.0d0) then
            vertex(ic)=vertex(ic)+g*delkappa*(v23*p31-v31*p32)
          endif
          if (delg1.ne.0.d0) then
           vertex(ic)=vertex(ic)+g*delg1*(v12*(p23-p13)-v23*p21+v31*p12)
          endif
          if (lambda.ne.0.d0) then
            vertex(ic)=vertex(ic) -g*lambda/wmass**2*
     1      (p31*p23*p12 - p32*p13*p21 + p_pmin*(p21*v23-p23*v12)
     2                                 + p_ppls*(p13*v12-p12*v31)
     3                                 + pmn_ppl*(p32*v31-p31*v23))
          endif
        endif
        enddo
      return
      end
      subroutine gen_g
C--------------------------------------------------------------------
      implicit NONE
      REAL*8 Q(4,7),DD,SIG(20),ECM,Q2,JACOB,
     .       COEFF,TWOPI,SIG1(6),WT, sigev(20),x(2),
     .       delkappa(6),lambda(6)
      INTEGER NMAX,NTEMP,NCUT,NGOOD,I,icode,ij,ik,k
      REAL  EGAMG,ECOSG,WTG(6),GSIG,PTG,XTG,WTGK(21),
     &      xexp(441),xexp1(21),xexp2(21)
      common /anom/ delkappa,lambda
      common /anom1/ xexp,xexp1,xexp2
      COMMON / INOUT / INUT,IOUT
      integer inut,iout
C--------------------------------------------------------------------
C
      CALL INPUT(ECM,NMAX,Q,JACOB,DD)
      q2=ecm**2
      TWOPI=6.2831853D0
      COEFF=2*Q2*TWOPI**5
c--
c      CALL INITH
c--
      CALL INITIALIZE
      do i=1,20
        sig(i)=0.d0
        sigev(i)=0.d0
      enddo
      x(1)=0.d0
      x(2)=0.d0
C   START GENERATING EVENTS
      ntemp=0
      NGOOD=0
      icode=1
      call bin2g(sig,x,ntemp,icode)
      write(iout,7880) ecm, nmax
 7880 format('# gen_g : Ecm=',f7.1,'   nmax=',i12)
      icode=2
C loop on events:
 99   ntemp=ntemp+1
      CALL MOMENTA(ECM,Q,WT,DD)
      NCUT=1
      CALL CHECK_CUTS(ecm,Q,NCUT)
      IF(NCUT.EQ.1) GOTO 99
      NGOOD=NGOOD+1
      call xsection(sig1,q)
      do i=1,6
c in pb
        sigev(i)=sig1(i)*wt*jacob/COEFF*0.3894D+9
        sig(i)=sig(i)+sigev(i)
      enddo
c--
      EGAMG = Q(4,5)
      PTG = DSQRT(Q(1,5)**2+Q(2,5)**2)
      ECOSG = DABS(Q(3,5)/Q(4,5))
      XTG = (2.*PTG)/ECM
      do ij=1,6
        wtg(ij) = sigev(ij)
      enddo
      do ik=1,21
        wtgk(ik) = xexp1(ik)*wt*jacob/COEFF*0.3894D+9
      enddo
c--
      x(1)=q(4,5)
      x(2)=q(3,5)/q(4,5)
      call bin2g(sigev,x,ntemp,icode)
      if(NGOOD.lt.nmax) goto 99
C end of loop on events ^^^^^^^
C
      do i=1,6
        sig(i)=sig(i)/NTEMP
        write (iout,1000) delkappa(i),lambda(i),sig(i)
      enddo
c--
      icode=3
      call bin2g(sig,x,ntemp,icode)
      write (iout,1001) NGOOD,ntemp
      return
C--------------------------------------------------------------------
 1000 format(2x,'delkappa,lambda,sig :',2x,f5.1,2x,f5.1,5x,e12.5)
 1001 format(2x,'gen_g : ngood=',i10,2x,'ntemp=',i10 )
      end
      subroutine bin2g(y,x,nev,icode)
C--------------------------------------------------------------------
c  binning, calculating chi^2 and printing
c  for ny quantities y(ny), their names cy(ny), ny<=20
c  as functions of nx<=2 variables x(nx), called cx(nx)
c               in nb1 and nb2 bins from xmin(nx) to xmax(nx), nb<=40
C ICODE=1:INITIALIZATION, =2:BINNING, =3:PRINTING
c nev - number of events
c for chi^2, the ny=1 corresponds to standard couplings
C--------------------------------------------------------------------
      implicit none
      real*8 y(20),x(2),xmin(2),xmax(2),lum,t(20,40,40),a(20,20)
     & , s(20,40,40),delk(21),lam(21),sigma,evmin,error,chilow,chihi
     & , b(20),de(2),xsec(20),bk(20),bl(20),xseck,xsecl,par
     & ,xsection
     & ,effi,xlumi,xsscale,xdata,xsdif
      real xexp(441),xexp1(21),xexp2(21)
 
      integer nx,ny,nev,icode,nb(2),ix1,ix2,ibin1,ibin2
     &   ,idum,ik,il,ix,iy,nb1,nb2,ine,i,ine1,ine2
      character*20 cy(20),cx(2)
C     MINIMUM OF EVENTS IN THE BIN FOR A BIN TO BE ACCEPTED
c and error
      parameter ( EVMIN=1.D0, ERROR=0.02D0 )
      integer inut,iout
      COMMON / INOUT / INUT,IOUT
c in common luminosity, matrix a   and anom. couplings
      common /lumino/ lum,a,delk,lam
      common /binning/ xmin,xmax,cx,cy,nb1,nb2,nx,ny
      common /anom1/ xexp,xexp1,xexp2
C--------------------------------------------------------------------
C
      GO TO (10,20,30) ICODE
 10   nb(1)=nb1
      nb(2)=nb2
      do ix=1,nx
         de(ix)=(xmax(ix)-xmin(ix))/nb(ix)
      enddo
      do iy=1,ny
        do ix1=1,nb1
          do ix2=1,nb2
            t(iy,ix1,ix2)=0.D0
          ENDDO
        ENDDO
      enddo
      return
C
 20   ibin1=idint((x(1)-xmin(1))/de(1))+1
      ibin2=idint((x(2)-xmin(2))/de(2))+1
      DO iy=1,ny
         t(iy,ibin1,ibin2)=t(iy,ibin1,ibin2)+y(iy)
      ENDDO
      RETURN
 
 30   continue
c invert t->s
c first total cross section
      do iy=1,ny
c         write(40,*) iy,y(iy)
         xsec(iy)=0.d0
         do idum=1,ny
            xsec(iy)=xsec(iy)+a(iy,idum)*y(idum)
         enddo
      enddo
      do iy=1,20
          bk(iy)=0.d0
          bl(iy)=0.d0
      enddo
      bk(1)=1.d0
      bl(1)=1.d0
      do iy=1,31
         par=0.2d0*(iy-16)
         bk(2)=par**2
         bk(4)=par
         bl(3)=par**2
         bl(5)=par
         xseck=0.d0
         xsecl=0.d0
         do idum=1,ny
            xseck=xseck+bk(idum)*xsec(idum)
            xsecl=xsecl+bl(idum)*xsec(idum)
         enddo
      enddo
c now t-> for binned xsection
      do ibin1=1,nb1
         do ibin2=1,nb2
             do iy=1,ny
                s(iy,ibin1,ibin2)=0.d0
                do idum=1,ny
                  s(iy,ibin1,ibin2)=s(iy,ibin1,ibin2)
     .                   + a(iy,idum)*t(idum,ibin1,ibin2)/nev
                enddo
             enddo
         ENDDO
      ENDDO
 
c  NOW CALCULATE CHI^2. THIS IS ASSUMING THAT SM CORRESPONDS TO
C                       iy=1
c for WWgamma
      ine = 0
      ine1 = 0
      ine2 = 0
      DO ik=1,21
         do il=1,21
            b(1)=1.d0
            b(2)=delk(ik)**2
            b(3)=lam(il)**2
            b(4)=delk(ik)
            b(5)=lam(il)
            b(6)=delk(ik)*lam(il)
            chilow=0.D0
            chihi=0.d0
            xsection=0.d0
            DO  ibin1=1,nb1
               do ibin2=1,nb2
c get sigma as functions of anomalous couplings
                  sigma=0.d0
                  do iy=1,ny
                     sigma=sigma+b(iy)*s(iy,ibin1,ibin2)
                  enddo
c low luminosity
                    IF(LUM*sigma.GT.EVMIN)
     .               chilow=chilow+LUM*(sigma-s(1,ibin1,ibin2))**2/
     .              s(1,ibin1,ibin2)/
     .                (1.D0+ERROR**2*LUM*s(1,ibin1,ibin2))
c high luminosity 10 times bigger
                    IF(LUM*sigma*10.d0.GT.EVMIN)
     .          chihi=chihi+10.d0*LUM*(sigma-s(1,ibin1,ibin2))**2/
     .              s(1,ibin1,ibin2)/
     .                (1.D0+ERROR**2*10.d0*LUM*s(1,ibin1,ibin2))
                 xsection=xsection+sigma
               enddo
            ENDDO
         enddo
      enddo
C
      RETURN
      END
      SUBROUTINE INPUT(ECM,NMAX,Q,JACOB,DD)
C--------------------------------------------------------------------
      IMPLICIT NONE
      character*20 cy(20),cx(2),outname
      REAL*8 ECM,Q(4,7),JACOB,DD,MZ,GZ
      REAL*8 ML,lum,one,half,k,l,k2,l2
     .  ,delkappa(6),lambda(6),kmax,lmax
      REAL*8  delk(21),lam(21),a(20,20),xmin(2),xmax(2)
      REAL*8 EPHOT,ANGLE,MVV,EPHOT0,ANGLE0,MVV0
      INTEGER N3,NMAX,n1,n2,ny,nx,ianom,nb1,nb2,nwwgi,nneutri
      integer nwwg,nneutr,nm0
      integer jtrig,namind
      real tabl
      COMMON / gengto / TABL(40)
      real ephmin,ephmax,xtfmin,xtfmax,costhm
C*CA PHCUTS
      COMMON / PHCUTS / EPHMIN,EPHMAX,XTFMIN,XTFMAX,COSTHM
      integer inut,iout
C*CC PHCUTS
      COMMON / INOUT / INUT,IOUT
      integer ifkalin
      common /kalino/ ifkalin
C
C Commons specific to this package:
      common/flags/nwwg,nneutr
      COMMON/MZGZ/MZ,GZ
      common/lumino/lum,a,delk,lam
      common/binning/xmin,xmax,cx,cy,nb1,nb2,nx,ny
      COMMON/LIMITS/ML
      COMMON/CUTS/EPHOT,ANGLE,MVV
      common/anom/delkappa,lambda
C vvvvvvvvvvvvv begin mods JB 970403 vvvvvvvvvvvvvvvvvvvv
C--------------------------------------------------------------------
C ---- Initialisation of internal constants:
c luminosity
      lum = 22.0D0
c parameters to calculate the 'a' matrix
      k = 10.0D0
      l = 10.0D0
c number of bins in two variables
      nb1 = 1
      nb2 = 1
c range of del(kappa) and lambda
      kmax = 10.0D0
      lmax = 10.0D0
c cut to eliminate Z+gamma background
      MVV = 0.0D0
c to turn on wwg coupling nwwg=1, to turn off nwwg=0
      nwwg = 0
      if (ifkalin.gt.0) nwwg = 1
C -----  Data from other commons in the program:
C Center-of-mass energy:
      ecm = DBLE(2.*TABL(16))
C Number of events accepted :
      nm0  = 100
      nmax = 0
      namind=1
      write(*,*) 'wild namind=',namind
      if (nmax.lt.nm0) nmax = nm0
c number of neutrino types,
c nneutr=1 only electron neutrinos
c nneutr=3 all neutrinos
      nneutr = TABL(12)
      if (nneutr.lt.1.or.nneutr.gt.3) write(iout,333)  nneutr
 333  format (/' ++ INPUT : wrong nneutr =',I5)
c Minimum photon energy:
      ephot = DBLE(EPHMIN)
C Minimum beam-photon angle:
      angle = DACOS(DBLE(COSTHM))
C ^^^^^^^^^^^^^^ end of mods JB 970403 ^^^^^^^^^^^^^^^^^^
c data for precomputing cross sections for a fixed set of couplings.
        ml=0.d0
        mz=tabl(13)
        gz=tabl(14)
        one=1.d0
        half=0.5d0
        do ianom=1,6
         delkappa(ianom)=0.d0
         lambda(ianom)=0.d0
      enddo
      delkappa(2)=-k
      delkappa(3)=k
      lambda(4)=-l
      lambda(5)=l
      delkappa(6)=k
      lambda(6)=l
c initialize matrix a for bin2g
      do n1=1,20
          do n2=1,20
            a(n1,n2)=0.d0
          enddo
      enddo
      k2=k**2
      l2=l**2
       a(1,1)=one
         a(2,1)=-1.d0/k2
         a(2,2)=half/k2
         a(2,3)=half/k2
            a(3,1)=-1.d0/l2
            a(3,4)=half/l2
            a(3,5)=half/l2
               a(4,2)=-half/k
               a(4,3)=half/k
                   a(5,4)=-half/l
                   a(5,5)=half/l
                       a(6,1)=1.d0/k/l
                       a(6,3)=-1.d0/k/l
                       a(6,5)=-1.d0/k/l
                       a(6,6)=1.d0/k/l
 
 20   FORMAT(10X,G20.10)
 21   FORMAT(10X,I10)
 22   format(10x,a20)
      write(IOUT,*)' --------------------------------------------'
      write(IOUT,*)' - INPUT : ----------------------------------'
      write(IOUT,*)' - for GENG generator -----------------------'
      write(IOUT,*)' - by J. Kalinowski -------------------------'
      write(IOUT,*)' - GENG is run in  initialization -----------'
      write(IOUT,*)' - GENG output is for technical checks ------'
      write(IOUT,*)' - PRINTED: variables: ecm, nmax and CUTS ---'
      write(IOUT,*)' - are used locally only, thus are dummy ----'
      write(IOUT,*)' - for the KORALZ run -----------------------'
      WRITE(IOUT,23) ECM,NMAX,nneutr
 23   format(2x,'ecm=',f8.2,'  nmax=',i8,' nneutr=',i8)
      write(IOUT,229) (delkappa(n1),n1=1,6)
 229  format(2x,'delkappa',6(2x,f5.1))
      write(IOUT,228) (lambda(n1),n1=1,6)
 228  format(2x,'lambda',6(2x,f6.1))
      write(IOUT,*)'matrix A'
      write(IOUT,227) (a(1,n1),n1=1,6)
      write(IOUT,227) (a(2,n1),n1=1,6)
      write(IOUT,227) (a(3,n1),n1=1,6)
      write(IOUT,227) (a(4,n1),n1=1,6)
      write(IOUT,227) (a(5,n1),n1=1,6)
      write(IOUT,227) (a(6,n1),n1=1,6)
 227  format(6(f5.1))
c ml=neutrino mass
      dd=-15.d0
c initialise incoming momenta, + Z axis along electron
      do n3=1,2
         q(1,n3)=0.d0
         q(2,n3)=0.d0
         q(4,n3)=ECM/2.d0
      enddo
      q(3,1)=-ECM/2.d0
      q(3,2)=ECM/2.d0
      JACOB=1.D0
c   for binning
      ny=6
      cy(1)='sm'
      cy(2)='delk=-1'
      cy(3)='delk=1'
      cy(4)='lamb=-1'
      cy(5)='lamb=1'
      cy(6)='delk=lamb=1'
      nx=2
      cx(1)='energy'
      xmin(1)=ephot
      xmax(1)=ecm/2.d0
      cx(2)='cos(angle)'
      xmin(2)=-dcos(angle)
      xmax(2)= dcos(angle)
c  delk and lam for bin2g
      do n1=1,21
          delk(n1)=kmax*(n1-11)/10.d0
          lam(n1)=lmax*(n1-11)/10.d0
      enddo
      WRITE(IOUT,2179) EPHOT,ANGLE,MVV
 2179 FORMAT(1X,'CUTS',/,' MINIMUM PHOTON ENERGY=',F8.3,/,
     .  ' JET-BEAM ANGLE=',F8.3,/,' NEUTRINOS OUTSIDE Z=',F8.3)
      RETURN
      END
